Title Page

Serial/IP® COM Port Redirector

OEM Edition with Encryption

Version 4.8.8

Revision A

Latest version on-line: Help File Download | HTML

30-day Trial Quick-Start Guide

End User License Agreement

Serial/IP is a registered trademark of Tactical Software, LLC.
Tactical Software is a registered trademark of Tactical Software, LLC.
Copyright © 1996–2009 Tactical Software, LLC. All Rights Reserved.
www.tacticalsoftware.com


Serial/IP Quick Start Guide

The Serial/IP Redirector

Serial/IP 30-Day Trial Quick Start Guide

The steps below tell you how to install and configure the Serial/IP Redirector so that your Windows applications can use virtual COM ports to access networked serial devices.

To get more detailed information at any step below, click on the [image] icon.

When you are done, your applications will be able to use serial servers instead of local serial devices.

1. Configure the serial server

Make sure that your serial server makes its serial ports available on TCP port numbers. You will use these port numbers in step 6 below.

Connect devices to server's serial ports that you will use in testing.

2. Install the Serial/IP software

Log in as Administrator.

Run the Serial/IP setup program.

Use all default choices.

To use the 30-day evaluation license, leave the license key blank.

The Serial/IP Redirector begins running. You do not need to restart Windows.

The Select Ports window automatically appears.

3. Ensure that firewall software permits connections

The Serial/IP setup program will automatically add an exception for Serial/IP in the Microsoft Windows Firewall.

If you are using other firewall software, you must manually add exceptions for UDP port 2392 (both inbound and outbound).

If a firewall blocks outbound connections, you must also add exceptions for any outbound TCP ports that are entered under the Port Number field in Serial/IP in step 6.

4. Create virtual COM ports

In the Select Ports window, check one or more boxes for the virtual COM ports you wish to create.

Click OK.

For Windows 98/95/Me: You must restart Windows before proceeding to the next step.

5. Configure a virtual COM port

In the Serial/IP Control Panel, select a virtual COM port.

Enter the IP Address of the serial server.

Enter the TCP Port Number that you configured in step #1.

If your serial server requires a login:

  • Check the box Use Credentials From

  • In the drop-down, select Use Credentials Below

  • Enter Username and Password

6. Use the Configuration Wizard

Click Configuration Wizard.

In the Wizard window, click Start.

When the Wizard completes, click Use Settings.

The correct settings will be automatically made for Connection Protocol and Application Compatibility.

7. Configure your application

In your application, change the COM port setting to the virtual COM port you created in step 4.

Your application should now be using the serial device on the serial server.

Having problems?

  • Double-check the settings for any firewall software that may affect connections used by Serial/IP. See step 3 above and the Local Computer Requirements topic.

  • Review the detailed step-by-step installation instructions in the Getting Started section of the User Guide.

  • See the recommended approach to troubleshooting in the User Guide.

  • Review the frequently asked questions and technical notes on the Tactical Software web site.


Installing a Trial Copy

The Serial/IP software can be installed as a temporary trial copy by leaving the license key blank during the installation.

  • The trial license can be used once on a given computer.

  • The trial time period (30 days) begins when the software is installed.

  • Up to 256 virtual COM ports can be used.

  • The encryption and application-configurable flow control options are not enabled unless you obtain a special trial license key from your supplier.

Notes

If you later purchase a license, use the Licensing command in the Serial/IP Control Panel to enter the purchased license key. You do not have to reinstall the software. Your virtual COM port selections and settings will be preserved.


Installing with a License Key

Using a seat license key

  • Be sure that you are using the Serial/IP Redirector setup program for seat-licensed software.

  • The setup program will prompt for the seat license key.

Related Topics

Features Controlled by the License Key


Installing an Update

If you are installing an update, please note:

  • The existing software must be the same major version (version 4).

  • The setup program will (with your permission) remove the existing Serial/IP software.

  • The license key will be preserved and used.

  • The virtual COM port selections and settings will be maintained.


Removing the Software

To remove the Serial/IP Redirector from the local computer

  1. Ensure that no applications are using Serial/IP COM ports.

  2. In the Windows Control Panel, open the Add or Remove Programs applet.

  3. Select the Serial/IP entry.

  4. Click Remove.

Notes

A restart of Windows is not necessary after uninstalling.

If you install an update release, the old software will be (with your permission) removed before the update is installed.


Local Computer Requirements

Platforms supported

  • Intel-compatible PC with 32-bit or 64-bit (x64) processor.
    Note: The Encryption feature is not available for 64-bit processors.

  • At least 4 megabytes free space on the boot drive

  • For seat licenses: Windows Vista (32-bit), Windows XP sp1 or sp2, XP 64-bit Edition, Server 2003, 2003 64-bit Edition, 2000, NT 4.0 sp6, 98/95/Me, Microsoft NT/2000/2003 Terminal Server, Citrix MetaFrame Access Suite

  • VMware

Software requirements

  • Windows Installer 2.0 or later. This software is included in Windows XP and later, and is available for NT 4.0, 2000 and 95 from the Microsoft Download Center. It is available for Windows 98 in Internet Explorer 5.5

  • Internet Explorer 4.0 or later (version 5.5 or later for Windows 98)

  • For Windows 95: Microsoft Windows Socket 2 update

Network requirements

  • A TCP/IP network connection from the local computer to the serial device server

  • The throughput and performance of the network connection must exceed the requirements of the application in total. (An Ethernet local area network will easily meet this requirement.)

Firewall requirements

  • The installer will add an exception for Serial/IP in the Microsoft Windows Firewall.

  • If Serial/IP is configured to answer incoming connections, then any TCP ports listed under Accept Connections must be entered into the exception list.

  • For other firewall programs, you will need to manually add exceptions for UDP port 2392 (both inbound and outbound).

  • If the firewall blocks outbound connections, add any outbound TCP ports that are entered under the Port Number field in Serial/IP.

Notes

The security of the data passing between the redirector and the server is subject to the security of the TCP/IP network, unless SSL/TLS encryption is being used by the redirector and server.

Related Topics

Encryption


Server Requirements

Serial device server configuration

  • The server must be configured to provide access to its shared serial devices by incoming TCP connections.

  • If possible, configure the server to use the Telnet protocol with the COM Port Control (RFC 2217) extensions. Otherwise, configure the server to use Telnet protocol or (as a last choice) raw TCP connections.

  • The server must use a dedicated TCP port number for each shared serial device and/or use a dedicated TCP port number that provides the first available serial device in a "hunt group" (called a "rotary" in Cisco IOS).

  • If you plan to use the redirector's encryption feature to secure the network connection to the server, the server must have SSL/TLS encryption capability and be configured as described in Encryption.

Serial device server network connection

  • The server must be on the same TCP/IP network as the user computers running the redirector.

  • Firewalls, if used, must allow connections on the TCP port numbers configured to provide access to shared serial devices.

Notes

When configuring a server, do not attempt to guess the TCP port number to use. The server documentation should contain specific information regarding the TCP port numbers that can be used for that brand and model.

Remember that TCP port numbers are not the same as serial port numbers on a server.

Related Topics

Encryption


Checklist for All Applications

Applications that need more serial port control

If the application needs to directly control (at run-time) the baud rate, parity, framing and/or receive real-time status signals for the serial ports on the server:

  • Use a serial server that supports the COM Port Control protocol.

  • Note: If serial port settings don't have to be changed on-the-fly by the application, they can usually be configured on the server instead. This may enable the use of a server that does not support the COM Port Control protocol.

Applications that use an untrusted network

If the network connection between your application and the server is untrusted (e.g., the Internet):

  • Use a server that supports SSL/TLS encryption.

  • Obtain and use a license key that enables the Encryption option.

  • For each virtual COM port use by this application, enable the option Use Encryption in the redirector. details

Related Topics

Finish the Port Settings

Configuring Advanced Options

Encryption

On the Web

Tactical Software Technical Notes


Preparing to Install

System requirements

  • The local computer must meet Local Computer Requirements.

  • The serial device server must meet the Server Requirements.

Information and software you will need

  • The redirector setup program.

  • Administrator privileges for the computers on which you install the redirector.

  • A license key for each copy of the redirector you install.

  • The IP address (xxx.xxx.xxx.xxx) or hostname of the serial device server.

  • The TCP port number(s) on which the server takes connections to use its serial devices.

When you're ready to begin...

Run the Setup Program

Notes

There is an exception to the requirement for Administrator privileges: The computer's security policy can be configured to allow "Privilege Elevation", such that portions of the setup procedure is run at elevated privileges by a user that does not have Administrator privileges.

Related Topics

Local Computer Requirements

Server Requirements

Features Controlled by the License Key


Run the Setup Program

The Serial/IP setup program is a .EXE file that prepares files and runs the Microsoft Installer to install the Serial/IP software on the local computer.

If this is the first time you have installed the software on this computer, you may use a built-in 30-day trial license by leaving the license key blank. The 30-day trial period starts at the time of installation.

To run the setup program

On the computer that will run the redirector:

  1. Log in as a user with Administrator privileges.

  2. If you are performing an upgrade, exit all Windows programs that use virtual COM ports.

  3. Run the Serial/IP setup program and follow its instructions.

  4. If you wish to restrict access to the Serial/IP Control Panel to users with Administrator privileges, select the feature Administrator Only Mode. (The redirector can still be used by anyone.) See notes below for details on this feature.

  5. At the end of software installation, the setup program will run the Serial/IP Redirector and display the Select Ports window, if this is the first time you have installed this redirector.

Next: Create Virtual COM Ports

Notes

The license key can be updated at any time using the Licensing command in the Serial/IP Control Panel.

If you use a license key that conflicts with the license key being used for a redirector on another computer, the redirector will display a window that displays information about the conflicting license key.

If the Serial/IP Redirector has been previously installed on this computer, the setup program restores the settings used by the prior installation.

The setup program asks for your name and company information. These fields are optional, and will appear in the Licensing window for your convenience. The name and company are entirely independent of the license key.

As an alternative to the setup program, MSI files are available on request from your supplier.

If you select the Administrator Only Mode feature, the Serial/IP Redirector will run for all users but the following restrictions will apply to users that do not have Administrator privileges:

  • The Serial/IP icon in the Windows System Tray will not appear.

  • The Serial/IP Control Panel will not be accessible.

  • The Check for Updates button in the About box is disabled.

Related Topics

Features Controlled by the License Key

License Key Help

License Key Conflicts


Create Virtual COM Ports

The Serial/IP Redirector requires that at least one virtual COM port be created.

The Select Ports window shows a list of COM ports (in the range of COM1 through COM4096) that are not already used. Any of these COM ports can be selected to become Serial/IP COM ports.

To create virtual COM ports

In the Select Ports window:

  1. Select at least one COM port to be a Serial/IP virtual COM port. Corresponding COM port ranges will automatically appear in the lower panel.

  2. Alternatively, you can directly edit the COM port ranges. Use individual COM port numbers (such as 4, 5, 7) and/or ranges (such as 11-18, 30-53) separated by commas. As you edit the COM port ranges, checkboxes in the upper panel will change accordingly. (Invalid numbers or ranges will be displayed.)

  3. Click OK.

  4. If you are running Windows 98/95/Me, you must restart Windows and resume the installation at the next step.

Next: Configure a Virtual COM Port

Tips

If you wish to make the built-in COM ports (e.g., COM1, COM2) on your computer available to be virtual COM ports, disable those ports in the BIOS and remove them in the Windows Device Manager.

Notes

Your license for the Serial/IP Redirector will enable some maximum number of active Serial/IP COM ports. You can select and configure any number of ports, but you can only use up the maximum number at one time.

If any Serial/IP COM ports are currently in use, you are not allowed to change the selected COM ports.

Legacy applications may not be able to use COM ports higher than COM4.

Related Topics

About Virtual COM Ports


Configure a Virtual COM Port

In this step, the first virtual COM port is configured and tested. The Serial/IP Configuration Wizard feature verifies the network connection to the server.

IMPORTANT NOTE: If the server uses encryption, it is recommended that you temporarily disable encryption on the server until you have successfully configured the virtual COM ports and verified operation with the server. See the topic Encryption for instructions on how to configure encryption and re-test virtual COM ports with encryption enabled.

To configure a virtual COM port

In the Serial/IP Control Panel:

  1. Select a virtual COM port in the list.

  2. Click Configuration Wizard.

  3. In IP Address of Server, type the IP address or hostname of the serial device server to be used by this virtual COM port.

  4. In Port Number, type the TCP port number at which the server provides access to the serial device. This TCP port number is determined when you configure the serial device server.

  5. If the serial device server requires user login, type values for Username and Password to be automatically provided by the redirector when the server prompts for the login.

  6. If this virtual COM port is using a modem connected to the serial server, select the check box for Test for presence of a modem.

  7. Click Start. Messages will appear in the Status and Log panels to show the redirector's interaction with the server. The Wizard typically takes 5 to 15 seconds to complete.

  8. Click Use Settings if it is enabled. The Configuration Wizard has completed successfully. The settings recommended by the Wizard will be applied to the virtual COM port and you return to the Control Panel.

  9. If Use Settings is not enabled, messages in the Status panel indicate the problem. See the topic Status Panel Messages for instructions.

Next: Specify a Credentials Source

Notes

If a presets file exists, an additional Preset pull-down menu will appear in the space above IP Address of Server field box. See the topic The Presets File for information about this feature.

A server failover feature allows you to specify more than one IP address or hostname. See IP Address and Port Number and Attempt Server Connection for details on how to use this feature.

If the server requires encryption, the redirector must use it as well. If these settings are not matched, the redirector will be unable to communicate with the server.

If the server requires encryption and the Serial/IP Control Panel does not have the check box Use Encryption, then the Serial/IP Redirector needs a license key that enables encryption. See Features Controlled by the License Key.

Related Topics

Using the Configuration Wizard

IP Address and Port Number

Failover Timeout

Use Encryption

Encryption


Specify the Credential Source

Getting Started :: Installation

Specify the Credentials Source

You can configure the redirector to obtain username and password credentials from one of four sources.

If the server does not require a user login, skip this step.

To specify the credentials source

In the Serial/IP Control Panel with the COM port selected:

  1. Select the Use Credentials From check box.

  2. To have the redirector automatically use the credentials currently shown in its Control Panel, leave the drop-down list set to Use Credentials Below.

  3. To have the redirector use the credentials provided when a user logs into Windows, select Windows Credentials. This becomes effective after the next Windows user login. NOTE: This feature is available only on Windows XP/2003/2000/NT (and not on multi-user operating systems).

  4. To have the redirector prompt for credentials every time a user logs in, select Prompt at Login. You then can click Prompt Now to enter credentials to be used for the remainder of this login session. NOTE: This feature is not available on multi-user operating systems (Microsoft Terminal Services, Citrix Metaframe).

  5. To have the redirector prompt the user for credentials every time the virtual COM port is used, select Prompt on COM Port Open. NOTE: This feature is available only on Windows XP/2003/2000/NT (and not on multi-user operating systems).

Next: Finish the Port Settings

Notes

If the serial device server is configured to not require user authentication, the checkbox Use Credentials From must be cleared.

By default, the redirector will prepend the current Windows domain to the username when using Windows Credentials. To prevent this, clear the Advanced Option Include Domain in Windows Credentials. details

Related Topics

User Credentials

Include Domain in Credentials


Finish the Port Settings

Some applications, in combination with some types of servers, may require the use of specialized per-port options provided by the redirector.

To finish the virtual COM port settings

Connection Protocol

In nearly all cases, the setting determined by the Configuration Wizard is correct and this setting should not be changed.

Signal handling

NOTE: If the server supports the COM Port Control protocol, these settings are unnecessary.

With the Serial/IP Control Panel open and the virtual COM port selected:

  1. If the redirector needs to emulate the DSR, DCD, and/or CTS signals, select the corresponding check box and select the desired emulation method from the corresponding drop-down list. details

Connection recovery

The redirector can attempt to restore its network connection to the server if the connection fails. To enable this feature on this virtual COM port:

  1. Select the check box Restore Failed Connections. details

  2. Review the related advanced options Keep-Alive Interval and Max Connection Recovery Interval.

Configuration of this virtual COM port is now complete

To configure the remaining virtual COM ports created earlier, see Configuring Additional Ports.

When all virtual COM ports are configured, proceed to Configuring Advanced Options.

Notes

When you change the settings for a virtual COM port, they are recorded immediately and are used the next time the port is opened.

Related Topics

Application Compatibility


Configure Additional Ports

To configure additional virtual COM ports

  1. In the Serial/IP Control Panel, select a virtual COM port.

  2. Use the same settings as another port if it is intended to use the same server and serial device. Otherwise, configure the port starting at the installation step Configure a Virtual COM Port.

  3. To copy the settings of the selected virtual COM port to other virtual COM ports, click Copy Settings To and specify the ports that will receive the settings.

Notes

If any virtual COM ports are in use, you can not use Select Ports.

Changes in selected ports become effective when you click OK. On Windows 98/95/Me, it is necessary to restart Windows after adding or removing a virtual COM port.

Related Topics

Simultaneous Connections

Using the Configuration Wizard


Configure Advanced Options

The following Serial/IP Redirector advanced options have default values that work well for most applications. These settings may be changed as needed to meet the needs of unusual applications.

NOTE: Settings for advanced options are global and apply to all virtual COM ports, not just the selected port.

Experimentation with these settings is strongly discouraged.

To configure advanced options

In the Serial/IP Control Panel, click Advanced to get the Advanced window, then select the Options tab. The following options are available:

  • Extend Server Connection

  • Attempt Server Connection

  • Synchronize with Server

  • Update Routing Table

  • Enable Nagle Algorithm

  • Always Limit Data Rate

  • Include Domain in Windows Credentials

  • Keep-Alive Interval

  • Max Connection Recovery Interval

Tips

The Use Defaults button restores the settings to the values used when the software is first installed.

Notes

Changes of settings for advanced options become effective the next time a virtual COM port is opened.

Related Topics

Checklist for All Applications

Advice for Specific Applications


Direct Access as COM Ports

To use virtual COM ports directly from your application

In your application:

  1. Find the "settings", "preferences" or "options" command in your application that allows you to configure which COM ports are used. Virtual COM ports will appear with the local COM ports.

  2. Select the virtual COM ports that you have configured (in the Serial/IP Control Panel) to access the serial device that you want to use on a serial device server.

  3. Your application now can use this COM port the same way it does a local COM port.

When using virtual COM ports:

  • In the Port Monitor, use the Activity panel to see a real-time summary of virtual COM port activity. details

  • In the Port Monitor, use the Trace panel to see a detailed record of virtual COM port operations and interactions with the serial device server. details

Notes

The serial device provided to a virtual COM port by a server is determined by a TCP port number used by the virtual COM port and the configuration of the server. Be sure you understand how the server is configured so that you get the serial device you expect.

Some older Windows applications do not recognize COM ports higher than COM4. Early versions of Windows HyperTerminal, for example, have this limitation. If you need to use such an application, create virtual COM ports in the COM 1-4 range.

A programming error (typically found in older applications) can cause the application to fail to open COM10 and above. If this defect in the application is not fixed, it is limited to using virtual COM ports COM1-COM9.

Related Topics

Hunt Groups

Create Virtual COM Ports

Select Ports

IP Address and Port Number


Recommended Approach

  1. Review the topic Checklist for All Applications to check for special needs your application may have and recommended settings.

  2. Use the Serial/IP Configuration Wizard if possible.

  3. If the application is unable to use the server at all, use the procedures that follow in this section, starting with Server Access.

  4. Use the Activity and Trace features of the Serial/IP Port Monitor to obtain more detailed information about the problem.

  5. Check the Frequently Asked Questions on the Tactical Software web site.

Tips

Server failures are by far the most common type of problem encountered. Unless the problem obviously involves the redirector, incorrect server configuration is the most likely underlying problem.


Diagnostics: Server Access

Getting Started :: Troubleshooting

Diagnostic — Server Access

Check the network connection

Ensure that the PC is connected to the server using the Microsoft TCP/IP networking software supplied with Windows. Open a DOS command prompt window and type in the ping command, using the server's network address or hostname in place of the xxx.xxx.xxx.xxx:

C:\ ping xxx.xxx.xxx.xxx

The output should indicate that ping has reached the server. If not, the redirector will not be able to use the server.

Check the IP routing table

If there is more than one default route, the redirector may not be able to determine a correct static route to the server.

To see the IP routing table:

  1. For Windows XP/2003/2000/NT, log into an account with administrator privileges.

  2. Open a DOS command prompt.

  3. Type the command route print.

In the command's output, the default routes appear at the top and show a Network Address value of 0.0.0.0. If the PC has more than one default route, the redirector may not be able to access a server that is not on the same subnet.

Verify DNS resolution of server's hostname

If you are using a hostname to configure the Serial/IP COM port, perform the 'ping' test above using the hostname instead of the IP address.

To verify that DNS can resolve a hostname:

  1. Open the Windows Command Prompt application.

  2. Type: nslookup <hostname>

  3. If the nslookup command is unable to associate an IP address to your hostname, then the redirector will also not be able to resolve the IP address.


Diagnostics: Server Connection

Getting Started :: Troubleshooting

Diagnostic — Server Connection

Use "telnet" to connect to the server (if it supports Telnet)

If the server supports Telnet protocol:

  1. Open the Windows Command Prompt application.

  2. Type telnet followed by the IP address and TCP port number, e.g.

    telnet 10.0.0.250 7000

  3. If the connection succeeds, you should be able to manually interact with the modem or serial device that the server provides at that TCP port number.

  4. If the server requires a user login, verify that the username and password that work here are the same as those configured in the Serial/IPControl Panel.


Diagnostics: Redirector Operation

Getting Started :: Troubleshooting

Diagnostic — Redirector Operation

Use HyperTerminal on the virtual COM port

In the HyperTerminal application:

  1. Create a new connection.

  2. In the Connect To window, select a configured virtual COM port.

  3. Click OK.

  4. In the terminal session, you should be able to interact with the modem or serial device on the server.

  5. To confirm operation as expected, use the Activity and Trace displays in the Serial/IP Port Monitor.


License Key Help

If your license key is not accepted by a Tactical Software product, please check the following potential problems:

  • Verify that the license ley has been typed correctly.

  • Administrator rights may be required to enter in the license key.

  • Verify that the license key is for the correct product.

  • Verify that the license key is for the major version of the software you are installing. For example, a version 3.x license key can not be used to install version 4.x software.

  • Verify that you aren't using an evaluation or timed license key that has expired.


License Key Conflict

A "license violation" or "license conflict" notification from a Tactical Software product indicates that it is unable to use its license key because a conflicting license key is in use by another computer. When this occurs, both installations of the software suspend function until the conflict is resolved by entering unique license keys.


About the Redirector

The Basics :: About the Serial/IP Redirector

What is a Redirector?

The Serial/IP Redirector lets your applications use serial devices provided by serial device servers on your network. This redirector does this by creating one or more virtual COM ports that make these networked serial devices appear to be connected to the local computer, even though they are physically located on servers.

This means that your serial device applications can begin using networked serial devices quickly, easily, and without software changes. Since the redirector's virtual COM ports work like standard Windows COM ports, your application software sees no difference between a local serial device and one provided by a serial device server.

Many brands and models of serial device servers are compatible with the Serial/IP Redirector due to its support of public TCP protocols that are widely supported by serial device server manufacturers.

Notes

A "COM port redirector" has a completely different function from software that "redirects" network connections and web browsers, such as URL redirectors, frame redirectors and domain redirectors.


Planning the Application

Successful operation of the Serial/IP Redirector with your specific application depends on the redirector, the server, the application, and the operating system it runs under. Taking time to properly plan and test is strongly recommended.

To plan the application

  • Review the local computer requirements that all user computers must meet.

  • If you are using Microsoft Terminal Services or Citrix MetaFrame Access Suite, review the Tech Notes on the Tactical Software web site for issues related to multi-user operating systems.

  • If you will use a server that supports SSL/TLS encryption, review the issues described in the Encryption section.

  • If you have a large number of users, consider using Unattended Installation. details

Tips

Unattended installation can dramatically reduce the time it takes to initially deploy the redirector and update it for a large user base.

Notes

All Tactical Software redirectors support encryption (if enabled by the license key). If you plan to use encryption, be sure that the server supports SSL and/or TLS encryption of the network connection with the redirector.

On the Web

Tactical Software Technical Notes


Features Controlled by License Key

The Basics :: About the Serial/IP Redirector

Features Controlled by the License Key

The Serial/IP Redirector uses a license key that enables its operation and controls optional features.

Maximum number of active virtual COM ports

  • COM ports 1 through 4096 can be configured.

  • The license key can enable between 1 and 4096 simultaneously active virtual COM ports. (Evaluation licenses are limited to 256.)

License expiration date

  • The trial version of Serial/IP Redirector uses a built-in license key that expires 30 days from time of installation.

The Encryption option

  • All encryption functions (data encryption and certificate processing) are available only if enabled by the license key.

  • If encryption is enabled, the license key also specifies the maximum cipher strength available when a connection is negotiated.

Application-configurable flow control

  • Some infrequently encountered legacy applications using networked serial devices require an ability to change between hardware and software flow control. The Serial/IP Redirector is able to perform this function if the serial device server supports the corresponding protocol.

  • Tactical Software redirectors disable this function by default. If needed, the feature can be enabled by a special license key.

Server lock

  • The Serial/IP Redirector may accompany a specific brand or model of serial device server and be licensed for use only with that server. For these versions of the redirector, the license key "locks" the redirector to that server product.

  • The server lock can be removed by replacing the default license key with a purchased license key.

Notes

A license key can be viewed and updated using the Licensing command in the Serial/IP Control Panel.

The user name and company that appears in the license window is for convenience only and does not affect the function of the license key.

If the same license key is used on more than one computer, the Serial/IP Redirector issues an error message.

Related Topics

Licensing

License Key Conflicts


Virtual COM Ports

The Serial/IP COM Port Redirector allows you to create virtual Serial/IP COM ports that provide access to serial devices on a server.

The redirector connects to the server when an application opens the COM port and disconnects from the server when the COM port is closed. One way to understand what the redirector does is to think of it as a "software cable" from the local computer across the local area network to serial devices on the server.

The redirector uses TCP network connections to the server to gain access to its serial devices. Before using the redirector, place the serial device server on your network and configure it to provide its devices on certain TCP port numbers.

As part of installing and configuring the Serial/IP Redirector, you use its control panel to configure each virtual COM port to a IP address and TCP port number that the redirector will use to connect to the server when that virtual COM port is opened. The Serial/IP Control Panel also contains global settings that apply to all Serial/IP COM ports.

The Serial/IP COM ports are available to software applications as conventional COM ports.

Related Topics

What Is A Redirector?


Simultaneous Connections

The Serial/IP Redirector can create up to 4096 virtual COM ports, from COM1 to COM4096.

A virtual COM port becomes active when an application on the local computer opens it. The redirector handles each active virtual COM port with a separate TCP connection to the server.

Additionally, the redirector processes each virtual COM port in its own thread. These threads run in parallel on hyperthreaded and multiprocessor computers.

The practical limit on active virtual COM ports for any given machine will depend on its RAM, processor speed, network performance, and other factors.

Notes

More than one Tactical Software redirector product can be installed on a computer, each using separate COM ports.

The license key used by the redirector sets an upper limit on the number of virtual COM ports that are active (open).

Some older applications are able to use COM ports only in the range of COM1 to COM4, and this limitation will apply to virtual COM ports as well.

Related Topics

What Is A Redirector?

Virtual COM Ports

Features Controlled by the License Key


Application Compatibility

Using a serial device server adds a network connection and a server to the data path between an application and the serial device it is using. For most applications, these differences are negligible.

For the unusual cases in which the network connection or server behavior can affect proper operation, the Serial/IP Redirector is able to compensate automatically in two ways:

  • The redirector contains numerous internal refinements to provide the best possible duplication of the behavior of a local COM port.

  • If the serial device server supports the COM Port Control protocol (IETF RFC 2217), the redirector can automatically use this network protocol to relay additional control and signal information.

Additionally, the redirector offers several options that may be used to make certain applications work with networked serial devices.

Per-Port Options for Application Compatibility

  • DSR/DCD/CTS Emulation

  • DTR is Modem Escape

  • Restore Failed Connections

Advanced Options for Application Compatibility

  • Extend Server Connection

  • Synchronize with Server

  • Update Routing Table

  • Enable Nagle Algorithm

  • Always Limit Data Rate

  • Include Domain in Credentials

  • Keep-Alive Interval

  • Max Connection Recovery Interval


Server Connection Recovery

The redirector can be configured to attempt to re-establish connection to the server if the connection fails. The Restore Failed Connections option enables this feature. The Keep-Alive Interval and Maximum Connection Recovery Interval options affect how it works.

By default, the redirector will attempt to re-connect to the server immediately (10ms) after that failed connection is detected. If that attempt is unsuccessful, it will attempt to reconnect on this schedule:

2nd: 1 second

3rd: 2 seconds (+/- 20%)

4th: 4 seconds (+/- 20%)

5th: 8 seconds (+/- 20%)

6th: 16 seconds (+/- 20%)

7th+: 30 seconds (+/- 20%)

Detection of the failed connection may be lengthy if the application is not currently sending data. TCP/IP connections do not automatically detect a failed connection if there is no traffic.

If the server supports the COM Port Control protocol, the redirector periodically sends a "keep-alive" message to the server so that a failed connection will be revealed. This message does not affect the redirector-server data stream. The message interval is set by the advanced option Keep-Alive Interval, which defaults to 60 seconds. details

The Maximum Connection Recovery Interval allows you to modify the maximum amount of time that the redirector will wait between connection attempts. This interval is set by the advanced option Maximum Connection Recovery Interval, which defaults to 30000ms (30 seconds). details

Changing this setting to 3000ms (3 seconds) would produce the following reconnection schedule:

1st: 10ms

2nd: 1 second

3rd: 2 seconds (+/- 20%)

4th+: 3 seconds (+/- 20%)

Typically this setting is used to force the redirector to try to connect at a short interval, however, it can also be used to increase the interval to longer periods of times than 30 seconds.


Using the Control Panel

To open the Serial/IP Control Panel

  • In the Serial/IP program group in the Windows Start Menu, click the Control Panel shortcut.

    OR

  • In the Windows System Tray, right-click the Serial/IP icon and click the Configure command.

    OR

  • In the Windows Control Panel, open the Serial/IP applet.

To configure a virtual COM port

  1. Open the Serial/IP Control Panel.

  2. Select a virtual COM port in the list at the left.

  3. View or change configuration settings for this virtual COM port.

  4. Your changes are recorded within 2 seconds.

  5. To apply the settings of the current virtual COM port to other ports, click Copy Settings To and select the ports to receive the settings.

To configure Advanced Options

  1. Open the Serial/IP Control Panel.

  2. Click Advanced.

  3. In the Advanced Settings window, select a tab and change settings.

  4. To record your changes, click OK.

Notes

If the Serial/IP Redirector has been installed with the Administrator-Only Mode feature, the Serial/IP Control Panel will be available only to users with Administrator privileges.

Changed settings do not affect the operation of currently active virtual COM ports.


Select Ports

The Select Ports command displays a window that allows you to see and change the Serial/IP COM ports.

To select virtual COM ports

In the Serial/IP Control Panel:

  1. Click Select Ports.

  2. Change the selected virtual COM ports by checking and clearing check boxes. Corresponding COM port ranges will automatically appear in the lower panel.

  3. Alternatively, you can directly edit the COM port ranges. Use individual COM port numbers (such as 4, 5, 7) and/or ranges (such as 11-18, 30-53) separated by commas. As you edit the COM port ranges, checkboxes in the upper panel will change accordingly. (Invalid numbers or ranges will be displayed.)

  4. Click OK.

Tips

When the redirector is first installed, you must select at least one virtual COM port. You can add and remove virtual COM ports, as long as at least one remains selected.

Notes

Select Ports is not available if any Serial/IP COM ports are being used by applications.

The list of available COM ports will not include COM ports for local hardware or any virtual COM ports created by other applications (such as printers and Bluetooth devices).

If you remove a virtual COM port and later create it again using the same COM port number, the settings of the removed virtual COM port are reinstated.

Related Topics

Create Virtual COM Ports

Simultaneous Connections


IP Address and Port Number

Using the Redirector :: The Serial/IP Control Panel

IP Address of Server and Port Number

The IP Address of Server and Port Number tells the redirector the location of the server on the network and the TCP port number on which the server will provide the correct device for this virtual COM port.

As noted below, up to four servers can be specified to activate the server failover feature.

To change these settings

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. In IP Address, type either:

    • A network IP address of the form xxx.xxx.xxx.xxx, e.g., 192.9.200.1.

      OR

    • A hostname if applicable, e.g., devserver or devserver.xyz.com.

  3. In Port Number, type the TCP port number at which the server provides the serial device.

These settings will be used the next time this virtual COM port is opened.

To use the server failover feature

If the Serial/IP Redirector is unable to connect to a server, it can automatically attempt to connect to backup servers if they are specified in IP Address.

To use the failover feature, enter up to four IP addresses (or hostnames) in IP Address separated by space characters.

Examples:

  • 192.9.200.1 192.9.200.2

  • devserver1.xyz.com devserver2.xyz.com

If the Redirector is unable to establish a connection to a server, it will attempt to connect to the next server in the list. Each connection attempt will use the same port number.

By default, the length of time for each connection attempt is governed by the Windows TCP/IP stack. The duration of the attempt can be limited with the Advanced Option Attempt Server Connection.

Tips

These settings do not have default values.

You can make your initial settings when a virtual COM port is first selected with Select Ports or when you run the Configuration Wizard.

IP Address must be changed if:

  • You are using a numbered IP address (xxx.xxx.xxx.xxx) and the network address of the serial device server changes.

  • You are using a hostname and it has changed.

Port Number must be changed if:

  • The serial device server has been reconfigured to provide the correct device at a different TCP port number.

Notes

These settings are not used to connect to the server until the Configuration Wizard runs or an application opens the virtual COM port.

Related Topics

Configure a Virtual COM Port

Attempt Server Connection


Accept Connections

To change this setting

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Select the Accept Connections check box.

  3. In the associated Port Number, type a TCP port number that is available on the local computer.

  4. The setting becomes effective without further action.

This setting will be used the next time this virtual COM port is opened.

A virtual COM port can be configured for outbound connections, inbound connections, or both.

Settings

Accept Connections set, Connect to Server blank

  • The virtual COM port can only accept connections.

  • User Credentials are disabled.

  • The Configuration Wizard is unavailable.

  • Extend Server Connection is disabled.

  • While waiting for an inbound connection, data sent to the COM port by the application is discarded.

  • If more than one Serial/IP COM port is configured to accept connections on the same TCP port number, arriving connections will go to the lowest numbered COM port that is available.

Accept Connections and Connect to Server both set

  • The virtual COM port can both initiate and accept connections.

  • User Credentials are enabled, but used only for outbound connections.

  • The Configuration Wizard is available for testing outbound connections only.

  • Deferred Port Open is disabled.

  • While there is no active connection, data sent to the COM port by the application is discarded.

  • CE_FRAME is not pulsed while the connection is down.

  • If Restore Failed Connections is enabled, it functions for outbound connections only. A failed inbound connection must be re-initiated by the other device/computer, and the Serial/IP Redirector will accept it.

  • If Restore Failed Connections is disabled, the Serial/IP Redirector initiates a connection when the Serial/IP COM port is first opened. If that connection fails or is terminated by the server, the Serial/IP Redirector begins waiting for an inbound connection until the COM port is closed by the application.

Notes

If you are using firewall software and Serial/IP will answer incoming connections, then any TCP ports listed under Accept Connections must be entered into the firewall's exception list.

Tips

Two copies of the Serial/IP Redirector can be configured for back-to-back operations. This provides a network equivalent of a serial crossover cable but with the speed and distance advantages of the network.

Some serial servers are able to run in "client mode" in which they initiate a TCP connection (to a preconfigured IP address and TCP port number) when a serial device becomes active. This allows a centralized application to passively collect data instead of actively polling.

Related Topics

Configure a Virtual COM Port


User Credentials

If the serial device server requires a login, the check box User Credentials From must be selected, otherwise it should not be selected.

When User Credentials From is selected, the redirector waits for the serial device server to prompt for a username and password. The virtual COM port can not be used by the application until the login sequence completes successfully.

To set User Credentials

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Check the Use Credentials From checkbox.

  3. In the drop-down list, select a source for the credentials.

These settings will be used the next time this virtual COM port is opened.

Settings

Disabled (default)

  • The redirector does not check for a login prompt from the server.

Enabled + Use Credentials Below

  • The redirector takes the credentials from Username and Password fields below.

  • These credentials are always used for this virtual COM port.

Enabled + Windows Credentials

  • The redirector obtains values for the username and password each time a Windows login occurs.

  • The redirector has no username or password until the next Windows login.

  • If the Advanced Option Include Domain in Windows Credentials is enabled, which it is by default, the redirector pre-prepends the current Windows domain to the username before sending to the server.

  • Note: This option is not available in Windows 98/95/Me or multi-user operating systems.

Enabled + Prompt at Login

  • Each time a user logs into Windows, the redirector displays a window requesting a username and password to be used while this user is logged in.

  • To enter credentials immediately, click Prompt Now.

  • Note: This option is not available for multi-user operating systems, such as Microsoft Terminal Services and Citrix MetaFrame Access Suite.

  • If a user is not logged in at the time a COM port is opened, the redirector proceeds as if Use Credentials From was not checked.

Enabled + Prompt on COM Port Open

  • Each time an application opens this virtual COM port, the redirector displays a window requesting a username and password to be used.

  • These credentials are used once, for this specific use of the virtual COM port.

  • If a user is not logged in at the time a COM port is opened, the redirector proceeds as if Use Credentials From was not checked.

  • When the application opens the virtual COM port:

    1. The redirector suspends the application.

    2. The redirector presents a dialog box that identifies the COM port and contains entry fields for user name and password.

    3. If the user clicks "OK", the redirector passes those credentials to the server.

    4. If the user clicks "Cancel", or does not click "OK" within 60 seconds, the redirector proceeds as if no credentials are required for this connection.

    5. The redirector waits for its connection to the server to become operational.

    6. The redirector resumes the application.

  • Note: This option is not available for Windows 98/95/Me or for multi-user operating systems, such as Microsoft Terminal Services and Citrix MetaFrame Access Suite.

Tips

Remember that the redirector just supplies the credentials, while the server processes them to determine whether the user will be allowed. Various types of serial device servers have differing capabilities for validating credentials using methods such as:

  • Usernames and passwords that are internally configured in the server.

  • The Windows domain controller.

  • RADIUS servers.

  • One-time password authentication systems, such as SecureID.

Notes

The user authentication process introduces a brief delay in gaining access to the modem or serial device.

If the serial device server does not require a login and User Credentials From is selected, the redirector will not connect to the server successfully because it will wait indefinitely for a login prompt.

User Credentials will be disabled if only incoming connections are permitted.

Related Topics

Specify the Credentials Source

Configuring Advanced Options

Include Domain in Credentials


Connection Protocol

The setting for Connection Protocol is the TCP/IP network protocol that the redirector uses in the network connection to the serial device server.

To set the Connection Protocol

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Select one of the three protocol settings in Connection Protocols.

  3. The setting becomes effective without further action.

The new setting will be used the next time this virtual COM port is opened.

Settings

Telnet

  • The redirector uses the Telnet protocol to connect to the server, using the settings for IP Address and TCP Port Number.

  • The redirector then negotiates Telnet options with the server.

  • The COM Port Control protocol is a Telnet protocol option that will be automatically used by the redirector if supported by the server.

Telnet with CR-Padding

  • The results are the same as the above Telnet setting, but CR/LF characters are padded with null characters.

  • This setting is rarely needed for a modern serial device server.

Raw TCP Connection (default)

  • The redirector uses a TCP/IP socket connection with no additional protocol.

  • The COM Port Control protocol will not be available (because it depends on the Telnet protocol).

Tips

The default setting is Raw TCP Connection only because all serial device servers support it.

The Telnet setting is generally the preferable setting, and can often be used since most servers are able to negotiate the Telnet protocol.

The Configuration Wizard reliably detects the correct setting for Connection Protocol.

Notes

Using the Telnet protocol does not mean that the connection is made on the standard TCP port for Telnet (port 23). The TCP port used is specified in the Port Number setting for the virtual COM port.

If there is a mismatch between the Connection Protocol setting and the serial device server's protocol support, various errors occur when the virtual COM port is used.

If a serial device server has a defective implementation of the Telnet protocol, it may not be 8-bit clean unless used with a raw TCP connection.

Related Topics

Configure a Virtual COM Port

Include Domain in Credentials

Using the Configuration Wizard

Server Requirements


DSR/DCD/CTS Emulation

Using the Redirector :: The Serial/IP Control Panel

Port Setting: DSR/DCD/CTS Emulation

The Serial/IP Redirector can emulate the behavior of the DSR, DCD, and CTS signals. This feature is primarily used when an application depends on changes in one or more of these signals and the server does not support the COM Port Control protocol, preventing relay of these signals from the server.

To set DSR/DCD/CTS Emulation

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Select a check box for an emulation setting to enable it.

  3. In the drop-down list, select an emulation method.

  4. The setting becomes effective without further action.

The new setting will be used the next time this virtual COM port is opened.

Settings

Disabled (default)

  • The redirector does not emulate the signals.

  • If the server supports the COM Port Control protocol, the signal will track the real-time condition of the signal as reported by the server.

  • If the server does not support the COM Port Control protocol, the signal is always indicated "low".

Enabled + Always High

  • Forces the signal to always indicate "high".

Enabled + Always Low

  • Forces the signal to always indicate "low".

Enabled + Track Connection

  • Causes the signal to indicate "high" when there is a network connection to the server and "low" otherwise.

Tips

Reasons to use DSR/DCD/CTS Emulation:

  • If the application needs to see a different pattern of signals than those relayed by the redirector from the server.

  • To compensate for lack of COM Port Control protocol support in the server.

  • To enforce certain signal behavior when two copies of Serial/IP are being used back-to-back.

Notes

If the Configuration Wizard detects server support for the COM Port Control protocol, it recommends disabled settings for the signal emulations.

If any signal emulation is enabled, it overrides the effects of the COM Port Control protocol.

Related Topics

Installing the Redirector: Finish the Port Settings

The Configuration Wizard: How It Works

System Requirements: Server Requirements | Checklist for All Applications


DTR is Modem Escape

The Serial/IP Redirector can simulate DTR signal transitions.

To set DTR is Modem Escape

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Select the check box DTR is Modem Escape.

  3. In the drop-down list, select an emulation method.

  4. The setting becomes effective without further action.

The new setting will be used the next time this virtual COM port is opened.

Tips

The default setting is disabled.

Notes

If the Configuration Wizard detects server support for the COM Port Control protocol, this option has no effect.

Related Topics

Installing the Redirector: Finish the Port Settings

The Configuration Wizard: Using the Configuration Wizard

System Requirements: Server Requirements | Checklist for All Applications


Restore Failed Connections

Using the Redirector :: The Serial/IP Control Panel

Restore Failed Connections to Server

This option causes the Serial/IP Redirector to attempt to restore failed network connections to the server.

To set Restore Failed Connections

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Select the check box Restore Failed Connections to Server.

  3. The setting becomes effective without further action.

The new setting will be used the next time this virtual COM port is opened.

Settings

Disabled (default)

  • The redirector takes no independent action to re-establish the connection.

  • For this virtual COM port, a connection to the server will not be restored until the application closes and reopens the virtual COM port.

Enabled

  • When the redirector notices that the TCP connection is broken, it will immediately attempt to reconnect to the server.

  • The reconnect attempt will be considered to have failed if the Windows TCP/IP stack indicates a failure or the interval in Attempt Server Connection expires, if that option is enabled.

  • If a reconnect attempt fails, the redirector tries again at increasing intervals until the connection is restored or the application closes the virtual COM port.

  • The maximum interval between attempts is determined by the setting of the advanced option Max Connection Recovery Interval. details

Tips

The Restore Failed Connections option should be used if the application can continue normal operation if a failed connection is automatically restored. Whether this is possible depends on:

  • What has happened on the server when the connection failed? Is the device still in an operable state?

  • If the redirector reconnects, will it get the same device?

  • Can the application tolerate a delay in detecting the failed connection and the time it takes to reconnect?

Notes

If the COM Port Control protocol is being used, the redirector uses keep-alive messages to discover a failed network connection more quickly. The interval between these messages is configurable with the advanced option Keep-Alive Interval. details

Related Topics

Installing the Redirector: Finish the Port Settings

Advanced Options: Max Connection Recovery Interval | Keep-Alive Interval


Use Encryption

If both the redirector and the server support SSL/TLS encryption, their network connection can be secured, protecting all setup information (notably, the server login sequence) and the data exchanged during the connection. Additionally, SSL/TLS support includes the ability to process certificates that prove the identity of the local computer and/or the server.

NOTE: This setting appears only if the redirector is using a license key that enables encryption

To configure a virtual COM port to use encryption

In the Serial/IP Control Panel:

  1. Select a virtual COM port.

  2. Select the check box Use Encryption.

  3. Choose an encryption protocol in the associated list.

  4. The setting becomes effective without further action.

The new setting will be used the next time this virtual COM port is opened.

Settings

Enabled

  • The redirector will require an SSL/TLS connection to the server.

  • The redirector will negotiate the connection according to the settings of the Advanced Options dialog, in the SSL Encryption, SSL Authentication, and SSL Certificate tabs.

Disabled (default)

  • The redirector will not use an SSL/TLS connection.

Tips

Using encryption requires a server that supports it as well.

The security provided by the encryption feature depends on the proper configuration of the server, its SSL/TLS certificate, and other issues that must be properly planned.

Notes

If the redirector uses encryption and the server does not, the connection fails with a generic error indication that does not directly suggest that the SSL/TLS negotiation was the problem.

Related Topics

Finish the Port Settings

Encryption


Licensing

The Licensing command allows you to edit the license key for a seat license.

To change Licensing

In the Serial/IP Control Panel:

  1. Click Licensing.

  2. In the Licensing window, edit the text information.

  3. Click Update.

The changes become effective immediately, but the operation of active virtual COM ports will not be affected until they are closed.

Settings

Name and Organization

  • These values are optional, and for your convenience. They are not related to the license key in any way.

License Key

  • License keys are issued in the format XXXX-XXXX-XXXX-XXXX-XXXX.

  • Upper and lower case is equivalent.

  • Dashes can be omitted.

Troubleshooting license key problems

If a license key is not accepted when entered:

  • Verify that the License Key has been typed correctly.

  • Note that, if the Windows registry has been configured for restricted access, Administrator rights may be required to enter in the license key.

  • Verify that the license key is for the correct product.

  • Verify that the license key is for the major version of the software you are installing. For example, a version 3.x license key can not be used to install version 4.x software.

  • Verify that you aren't using an evaluation or timed license key that has expired.

A "license violation" or "license conflict" notification from a Tactical Software product indicates that it is unable to use its license key because a conflicting license key is in use by another computer. When this occurs, both installations of the software suspend function until the conflict is resolved by entering unique license keys.

Tips

The license key can be entered during software installation. If it is omitted, a temporary trial license key is automatically installed.

Closing the Licensing window (with the 'x' box) is the same as clicking Cancel.

Related Topics

Installing with a License Key

Features Controlled by the License Key


Using the Configuration Wizard

Starting with a few basic settings that you provide, the Configuration Wizard detects and interrogates the serial device server to help you determine the correct settings of important redirector options.

To run the Configuration Wizard

In the Serial/IP Control Panel:

  1. Select a virtual COM port in the list.

  2. In User Credentials, select Use Credentials Below, if the server requires login.

  3. Click Configuration Wizard.

In the Configuration Wizard window:

  1. If the following settings are not correct, enter them now:

    • IP Address of Server and Port Number details

    • Security details

  2. If the server requires a user login, type valid credentials in Username and Password.

  3. Click Start.

As the Wizard runs, the Status panel shows a summary of server characteristics and the Log panel shows the Wizard's interaction with the server.

If the Configuration Wizard fails

The Wizard indicates errors in the Status panel, with details in the Log panel. To run the Wizard again:

  1. Analyze error messages in the Status panel. details

  2. If necessary, analyze the messages in the Log panel. details

  3. Correct the Wizard settings.

  4. Click Start to run the Wizard again with those settings.

When the Configuration Wizard succeeds

The Wizard indicates a successful run by messages in the Status panel and enabling the button Use Settings. To finish:

  1. Click Use Settings to return to the Control Panel.

  2. If User Credentials are being used, you can now change the source of these credentials as appropriate. details

  3. The setting for Connection Protocol should be left as is.

  4. The following settings may need to be set for your application, but only if the Wizard has not detected COM Port Control protocol support by the server:

    • DTR is Modem Escape details

    • DSR/DCD/CTS Emulation details

  5. If your application requires Restore Failed Connectoins, configure those settings. details

  6. The setting for Security should be left as is.

Notes

To copy the contents of the Status and Log panels to the Windows clipboard, use the Copy button.

The only Advanced Options setting that affects the operation of the Wizard is Include Domain in Windows Credentials.

Related Topics

Status Panel Messages

Log Panel Messages

Configure a Virtual COM Port


Status Panel Messages

Normal progress messages

Connected to server

  • The TCP connection to the server has been established.

  • If encryption is being used, SSL/TLS negotiation has succeed, including any related certificate processing.

Telnet protocol detected

  • The server has responded to the Wizard's attempt to use the Telnet protocol.

  • The Wizard has determined if the server's implementation of Telnet uses CR padding.

COM Port Control support detected

  • The server has indicated that it supports the COM Port Control option of the Telnet protocol.

Server signature <signature>

  • Shows the signature sent by the server via the COM Port Control protocol.

  • Signature information varies according to server manufacturer and model.

Session completed

  • The Wizard has finished interactions with the server.

Connection error messages

Client not licensed for this server

  • The license key being used by the redirector restricts use to a specific server manufacturer and/or model, and this server does not qualify.

  • Occurs when using an OEM version of the redirector with an unsupported server.

Server connection failure
Error connecting to <server IP address>
Error sending data

  • The IP Address and/or TCP Port Number may be incorrect.

  • If IP Address contains a hostname, the redirector may have encountered a failure to resolve the hostname due to a problem with domain name service (DNS) on this network.

  • If the Use Encryption option is selected, the server may not be negotiating an SSL/TLS connection or is not receiving/accepting the redirector's certificate.

User authentication error messages

Server expecting username

  • The Wizard has detected a login prompt, but the Username setting is blank.

Server expecting password

  • The Wizard has detected a password prompt, but the Password setting is blank.

Username and/or password incorrect

  • The server is not accepting the values provided for Username and/or Password.

  • The server may be requiring that the username include the Windows domain, but the advanced option Include Domain in Credentials is not enabled. details

No login/password prompts received from the server

  • The settings for Username and/or Password are not blank, but the server has not issued a login prompt, probably because the server is not configured to require a login.

Server requires username/password login

  • The Wizard has detected a login prompt, but Use Credentials From has not been selected in the Control Panel. details

"Prompt at Login" selected but no credentials present

  • In the Control Panel, Prompt at Login has been selected but no credentials have yet been entered. details

"Windows Credentials" selected but no credentials present

  • In the Control Panel, Use Windows Credentials has been selected but no credentials have been stored. This occurs when no user login has occurred since this setting was made. details

Notes

If error messages occur, the Log panel often provides helpful information. details

To copy the contents of the Status (and Log) panels to the Windows clipboard, use the Copy button.

Related Topics

Using the Configuration Wizard

Log Panel Messages


Log Panel Messages

General error messages

Bad IP address

  • The Wizard is unable to use the setting of IP Address.

Server disconnected prematurely

  • The Wizard was able to establish a connection to the server, but it was terminated by the server before the Wizard finished.

Internal error

  • The Wizard has received data from the server that it is unable to process.

Connection error messages

CONNREFUSED

  • The server is not accepting connection on the TCP Port Number.

  • The IP Address may be incorrect and the connection is being attempted to an unintended destination on the network.

NETUNREACH, TIMEDOUT, HOSTUNREACH

  • The IP Address may be incorrect.

  • The local computer's IP routing table does not contain a route for packets to IP Address.

NAMETOOLONG, AFNOSUPPORT

  • The IP Address is malformed (e.g., xxx.xxx.xxx) or a non-existent hostname.

ADDRNOTAVAIL

  • A server at IP Address is not available.

NETDOWN

  • The network has failed or IP Address is incorrect.

CONNABORTED, CONNRESET, NOTCONN, SHUTDOWN, EDISCONN

  • The server has terminated the connection.

  • The server may have failed.

Notes

If error messages occur, the Status panel may provide helpful context. details

To copy the contents of the Status (and Log) panels to the Windows clipboard, use the Copy button.

Related Topics

Using the Configuration Wizard

Status Panel Messages


Extend Server Connection

Using the Redirector :: Advanced Options

Extend Server Connection (ms)

A common Windows programming technique is to hand off a COM port from one process to another. The underlying assumption is that the second process can open COMxx and be connected to exactly the same device. This option causes the redirector to extend its connection to the server (and access to the device) for a designated interval that begins when the virtual COM port is closed by the application.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. To change the delay time, type a number of milliseconds in the range 1 to 4,294,967,296.

  4. To disable the delay:

    • Clear the check box Extend Server Connection, or

    • Type a 0 or a blank for the delay time.

  5. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Enabled (default, 8000 milliseconds)

  • When the virtual COM port is closed, the redirector maintains its connection to the server for the specified number of milliseconds.

  • If the virtual COM port is opened (by any application) before the interval ends, it immediately has access to the same modem or serial device as the prior user of the virtual COM port.

Disabled

  • When the virtual COM port is closed, the redirector immediately closes the network connection to the server.

Notes

This is a global setting that affects all Serial/IP COM ports.

Currently open ports are unaffected.

The maximum delay value (a 32-bit unsigned integer) is approximately 4.3 billion milliseconds, which is about 49 days.

Related Topics

Configuring Advanced Options


Attempt Server Connection

When the Serial/IP Redirector attempts a TCP/IP connection to a server, the connection may fail after a timeout period if the server is unresponsive or some other network condition prevents a connection. By default, a connection failure is determined by the Windows TCP/IP stack based on network activity (or lack thereof) and may be 10 to 15 seconds or longer.

You can limit the timeout period by enabling Attempt Server Connection and specifying a number of milliseconds. If this setting is used, the redirector terminates pending connection attempts if they do not succeed in the specified time.

Attempt Server Connection affects the following redirector features:

  • Server failover, if used. For more information on the server failover feature, see IP Address and Port Number.

  • Server synchronization, if used. The Attempt Server Connection option can effectively cap the time the redirector will wait for a server to complete the COM port open sequence. For more information, see the notes in Synchronize with Server.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. To enable the option:

    • Check the checkbox Attempt Server Connection.

    • Type a number of milliseconds in the range 1 to 4,294,967,296.

  4. To disable the option:

    • Clear the check box Attempt Server Connection, or

    • Type a 0 or a blank for the milliseconds value.

  5. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Disabled (default)

  • A TCP/IP connection attempt will fail based only on processing by the Windows TCP/IP stack.

Enabled (default value 2000 milliseconds)

  • A TCP/IP connection attempt will fail if either the Windows TCP/IP stack does not succeed or the specified time period expires, whichever occurs first.

Tips

The Windows TCP/IP stack does not use a fixed timeout period to determine that a connection attempt has failed.

Notes

This is a global setting that affects all Serial/IP COM ports.

Changes become effective for subsequently opened virtual COM ports. Currently open ports are unaffected.

Related Topics

IP Address and Port Number

Keep-Alive Interval

Configuring Advanced Options

Recover Failed Connections


Synchronize with Server

Some applications require that the COM port open operation should "synchronize" with the server by waiting until the server provides the serial device and returning a failure from the COM port open function otherwise.

To set Synchronize with Server

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Use the check box Synchronize with Server.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Enabled (default for Windows NT/2000/XP)

The redirector defers the return from the COM port open until all of the following occur between the redirector and the server:

  • The redirector-server network connection succeeds.

  • SSL/TLS negotiation succeeds (if used).

  • Telnet (with COM Port Control if possible) is negotiated.

  • Server login succeeds (if used).

Disabled (default for Windows 98/95/Me/NT)

The redirector immediately returns from the COM port open with a success status.

Tips

This setting provides an alternative way for the application to detect the error condition: a failed return from OpenFile().

By default, the Windows TCP/IP stack alone determines if an attempt has failed, and the time it requires to make that determination can vary widely depending on the underlying cause of the problem. The redirector's Advanced Option Attempt Server Connection can be used to impose a limit on the time the redirector will wait for a connection attempt to succeed.

Notes

This is a global setting that affects all Serial/IP COM ports.

Currently open ports are unaffected.

When a virtual COM port is opened, the default behavior of the redirector in most cases is to return a success from the call to OpenFile() while the redirector proceeds to set up the connection to the serial device server. If the serial device server is unable to provide a serial device, the COM port remains open.

Most applications detect the error condition by the absence of the expected serial device behavior on the open COM port and the application closes the COM port.

Related Topics

Configuring Advanced Options


Always Limit Data Rate

Using the Redirector :: Advanced Options

Always Limit Data Rate to COM Port Baud Rate

The Serial/IP Redirector can be configured to limit the data rate to the baud rate that is in effect for the virtual COM port.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Select the Always Limit Data Rate to COM Port Baud Rate check box.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Enabled

  • The redirector will throttle its output data rate to not exceed the baud rate that is currently in effect on the virtual COM port.

  • There is no effect on input data rate.

  • If the virtual COM port is connecting to a server that supports COM Port Control, this setting has no effect.

Disabled (default)

  • The output (and input) data rate are not artificially limited by the redirector.

Tips

Since the Serial/IP Redirector is relaying data to the server over a network connection, the rate at which it sends data to the server can be network speed until various buffers fill in the local computer, the network, and/or the server software. Consequently, the application using the redirector may incorrectly assume that all data has been sent by the serial device because all writes to the virtual COM port have completed. This is not a problem for most applications.

If the server supports the COM Port Control protocol, the server is able to exercise control over the rate at which the redirector sends data. Otherwise, if this option is disabled, the redirector ignores that baud rate setting and lets the server accept data as quickly as it can.

Notes

Applications can change the baud rate of a virtual COM port using the standard COM port API.

This is a global setting that affects all Serial/IP COM ports.

Currently open ports are unaffected.

Related Topics

Configuring Advanced Options


Update Routing Table

The Serial/IP Redirector can automatically maintain its IP route to a server on a different subnet by modifying the IP routing table.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Use the check box Update Routing Table.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Enabled (default)

  • When a virtual COM port is opened, if server is not on the same subnet as the local computer, the redirector inserts into the IP routing table a host route to the server, if such a route does not already exist.

  • As virtual COM ports are closed, the redirector removes the host route it added, since that route is no longer needed.

Disabled

  • The redirector does not update the IP routing table.

Notes

Some applications (notably Windows Dial-Up Networking and similar PPP applications) change the local computer's default route in the IP routing table when they establish their connection to the remote network. When this change is made, if the local computer is not on the same subnet as the serial device server, it no longer has a route to the server and Serial/IP Redirector loses its connection to the server. The redirector can solve this problem by creating host routes in the IP routing table.

Such changes to the routing table are not permitted by some VPN software, however. If the local computer is connected to the server through a VPN, the redirector's automatic update of the routing table may need to be disabled, using the Update Routing Table option.

This is a global setting that affects all Serial/IP COM ports.

Currently open ports are unaffected.

Related Topics

Configuring Advanced Options


Enable Nagle Algorithm

The Nagle algorithm is a method employed by the Windows TCP/IP stack to coalesce small TCP/IP packets. This can affect the packetization and arrival time of data between the redirector and the server.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Select the Enable Nagle Algorithm check box.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Enabled (default)

  • The TCP/IP stack operates under its default setting (Nagle enabled).

Disabled

  • The redirector disables the use of the Nagle algorithm in the TCP/IP stack.

Tips

The purpose of the Nagle algorithm is to provide better network efficiency while imposing a minor latency on the data stream while it waits to fill network packets. For most applications, this effect is transparent.

For applications that are especially sensitive to data timing, however, the Nagle algorithm may cause application errors that can be solved by clearing Enable Nagle Algorithm. Examples include applications that send short messages and wait for an acknowledgement.

Notes

This is a global option that affects all Serial/IP COM ports.

Currently open ports are unaffected.

Related Topics

Configuring Advanced Options


Include Domain in Credentials

Using the Redirector :: Advanced Options

Include Domain in Windows Credentials

Some servers that require user login may need the username to start with the Windows domain name.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Select the Include Domain in Windows Credentials check box.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Settings

Enabled (default)

  • If the source of user credentials is Windows Credentials, the redirector automatically pre-prends the current Windows domain to the username.

  • For any other source of user credentials, this option has no effect.

Disabled

  • The username is sent to the server exactly as obtained from the credential source.

Tips

If the Windows domain is "mydomain" and the username is "smith", this option causes the username to be sent as "mydomain\smith".

Notes

This is a global option that affects all Serial/IP COM ports.

Currently open ports are unaffected.

Related Topics

Configuring Advanced Options


Keep-Alive Interval

If the server supports the COM Port Control protocol, the redirector can use a keep-alive message method to detect a failed connection to the server. This option controls the interval at which the redirector will issue the keep-alive message, if no activity has occurred on the connection.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Type a value for Keep-Alive Interval. The default is 60,000 milliseconds. It is recommended that this setting be at least 1,000 milliseconds.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Tips

One of the basic characteristics of a TCP/IP connection is that one end of the connection may fail without automatic notification to the other end.

If Restore Failed Connections is enabled on any of its virtual COM ports, and if the COM Port Control protocol is being used, the Serial/IP Redirector periodically emits a "keep-alive" message to the server, which responds with an acknowledgement. This action monitors the existence of the connection. The interval between attempts by the redirector to reach the server is 60 seconds by default. This means that as much as 60 seconds may elapse before the redirector discovers that the connection has failed.

To shorten the maximum time of an undetected failure, a smaller value for Keep-Alive Interval can be used. The penalty of shorter intervals is increased network traffic and overhead on the local computer and server.

Notes

This option affects the handling of only those virtual COM ports that have Restore Failed Connections enabled and are connected to a server that supports the COM Port Control protocol.

If there is activity on the redirector-server connection during the keep-alive interval, the redirector does not issue a keep-alive message.

This is a global option that affects all Serial/IP COM ports.

Currently open ports are unaffected.

Related Topics

Max Connection Recovery Interval

Configuring Advanced Options

Recover Failed Connections


Max Connection Recovery Interval

Using the Redirector :: Advanced Options

Maximum Connection Recovery Interval

This option controls the maximum time between the redirector's attempts to reconnect to the server if Restore Failed Connection is enabled for a virtual COM port.

To change the setting

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Select the Options tab.

  3. Type a value for Maximum Connection Recovery Interval. The default is 30,000 milliseconds (30 seconds). It is recommended that this setting be at least 1,000 milliseconds.

  4. Click OK to record the setting.

This setting affects all Serial/IP COM ports that are subsequently opened.

Tips

If the Serial/IP Redirector discovers that its connection to the server has failed, it will begin attempting to restore the failed connection if the option Restore Failed Connection has been set for the virtual COM port.

If an application needs faster reconnection attempts, set this option to a shorter interval.

Notes

This is a global setting that affects all Serial/IP COM ports.

Changes become effective for subsequently opened virtual COM ports. Currently open ports are unaffected.

Related Topics

Keep-Alive Interval

Configuring Advanced Options

Recover Failed Connections


Using the Port Monitor

The Serial/IP Port Monitor can be opened by:

  • Double-clicking the Serial/IP icon in the Windows System Tray.

  • Right-clicking the Serial/IP icon in the Windows System Tray and choosing the Port Monitor command.

  • In the Serial/IP Control Panel, click Port Monitor.

Multiple Port Monitor windows can be open simultaneously and configured separately.

Related Topics

The Activity Panel

The Trace Panel


The Activity Panel

The Activity panel provides a real-time display of the status of all Serial/IP COM ports.

Port

  • The virtual COM port number label for the row. This label always appears.

  • If a presets file is being used, the preset name for this port (if applicable) appears in the next column.

Line signal indicators

  • TD indicates data are being sent to the server.

  • RD indicates data are being received from the server.

  • TR (DTR) is the signal from the application to the server that the application has opened the virtual COM port. The most common use of DTR is to programmatically lower it to signal a modem to disconnect.

  • DR (DSR) is the signal from the server to the application that a modem or serial device is connected to the server and ready to communicate.

  • CD (DCD) is the signal from the server to the application that a modem has successfully negotiated a connection with another device.

Notes

The line signal indicators appear only when the virtual COM port is currently opened by an application.

The TR, DR, and CD indicators appear only if the COM Port Control protocol is being used or if the COM port options are enabled.

Related Topics

Using the Port Monitor

The Trace Panel


The Trace Panel

The Trace panel provides a detailed, time-stamped, real-time display of all Serial/IP COM ports operations. When enabled, the display is updated every one second.

This feature is typically used to debug application problems. Because the Trace feature has some impact on memory usage and system performance, it is typically only enabled temporarily.

The data that appears in the Trace panel can be copied to the clipboard or saved to a file for off-line analysis.

Using the Trace display

  1. Open a new Port Monitor window. details

  2. Click the Trace tab. The display area will initially be blank.

  3. Select the check box Enable Trace.

  4. Begin application operation that uses Serial/IP COM ports.

  5. Recreate the problem condition that you are debugging.

  6. To save the trace data to a file for off-line analysis, use the File / Save As menu command. This file uses a binary format that preserves all data and can be opened later in a Trace window using the File / Open menu command.

  7. To capture the trace data in text format to the Windows clipboard, use the Edit / Copy menu command. The text then can be pasted into other Windows applications.

Configuring the Trace panel

  • Clear removes all data from the display and resets the trace data collection mechanism in the redirector.

  • Enable Trace starts and stops trace data collection and display.

  • Hex Display toggles the format of the display between ASCII text (more readable) and hexadecimal format (most detailed).

  • Auto Scroll causes the display to show the most recent trace data continuously.

  • Always on Top causes this Port Monitor window to remain on top of the windows of other applications.

Using the Trace Options menu

  • Select Ports to Capture allows you to reduce the number of ports that are being traced to a subset of all configured virtual COM ports. For large applications, this feature reduces the impact of tracing on memory and system performance.

  • Select Ports to Display allows you to reduce the number of ports that appear in the display to a subset of the ports being captured. For large applications, this feature provides a way to focus on ports of interest among all those being captured.

  • Buffer Size changes the amount of RAM being used for tracing.

  • System Debug Output sends trace data to the system debug channel, with an optional label.

Event messages

The Trace display shows one event per line, in time order. Every event begins with a time tag.

Transmit events

  • Shown in green and preceded by "»"

  • Shows data written to the virtual COM port.

  • Contents: the data transmitted, either in ASCII or hexadecimal format, depending upon the current display mode.

Receive events

  • Shown in red and preceded by "«"

  • Shows data read from the virtual COM port.

  • Contents: the data received, either in ASCII or hexadecimal format, depending upon the current display mode.

Control events

  • Shown in blue and preceded by "|"

  • Shows all non-data events.

  • Contents: setting of session parameters (such as Telnet); opening and closing a port; connecting to the modem server; setting a device control or status line (DTR, DSR, DCD, etc); and the configuration of baud rate and framing parameters.

Notes

The Trace display covers up to 512k bytes of event data, enough to cover a reasonably extensive tracing session. If the limit is reached, the trace clears and starts over.

Related Topics

Using the Port Monitor

The Activity Panel


The Presets File

Commonly used configurations for COM ports can be specified in an optional "presets file" that contains pre-defined, named settings for virtual COM port options. The names of available presets appear in a drop-down list named Presets in the Serial/IP Control Panel. If an entry is selected, all virtual COM port settings specified by that entry are immediately changed for the currently selected virtual COM port.

The presets file is named "presets.txt" and is located in the Serial/IP software installation folder:

        C:\Program Files\Tactical Software\SerialIP

The format of the presets file is described in Presets File Entries.

Tips

The presets file is a convenient way to manage settings that need to be changed frequently, especially if several settings need to be changed together. Rather than retype an IP address, TCP port number and all the other configuration settings, a user can simply select them from the Presets drop-down list in the Serial/IP Control Panel.

The location of the presets file can be specified by changing the Windows registry entry PresetsFileSpec (a REG_SZ) in HKEY_LOCAL_MACHINE/Software/Tactical Software/SerialIP/4.0/. This allows a presets file to be placed on a server as a shared file for multiple users.

Notes

The presets drop-down only appears in the Serial/IP Control Panel if a presets.txt file exists when the Serial/IP Control Panel starts.

Configuration presets are available for virtual COM port settings only, not advanced options.

All settings can be automated during installation using the Unattended Installation feature.

For the Serial/IP Redirector, settings can also be changed directly at run-time by the application using the Configuration API.

Related Topics

Presets File Entries


Presets File Entries

The presets.txt file is a text file containing one or more preset entry. Each entry is a single line and consists of a label followed by one or more settings.

Entry format

All entries have the same format:

<Label>,<IP Address>,<Port Number>,
        <Inbound Port Number>,<Auth Option>,
        <Connection Protocol>,<SSL Negotiation>,
        <COM Port Options>,...

No extra spaces are allowed except within the Label field.

Fields must appear in the order given above.

The field Inbound TCP Port Number is optional.

Examples

Server 1,10.0.0.251,7000,noauth
Server 2 SSL,10.0.0.252,7000,authwindows,ssl
Server 3A,10.0.0.253,5000,authmanual,raw,dun,dsr,dcd,reconnect
Server 3B,10.0.0.253,5000,authmanual,raw,dun,dsr,dcd,reconnect

Settings in order of appearance

Setting | Value | Description
Label
 | text string (required) | The label to be used in the Presets drop-down list in the Serial/IP Control Panel. Can contain embedded spaces. Also appears in the Activity panel of the Port Monitor.
IP Address
 | xxx.xxx.xxx.xxx or hostname (required) | IP Address of Server
Port Number
 | valid TCP port number (required) | Port Number
Inbound Port Number
 | valid TCP port number | Port Number for Accept Connection
Auth Options
 | noauth (default) | No Login Required
 | authwindows | Use Windows Credentials
 | authloginprompt | Prompt at Login
 | authmanual | Use Credentials Below
 | authportopenprompt | Prompt on COM Port Open
Connection Protocol
 | telnet | Telnet
 | crpad | Telnet with CR Padding
 | raw | Raw TCP Connection
SSL Negotiation
 | nossl (default) | Use SSL/TLS disabled
 | ssl | Negotiate SSL v3 or TLS v1
 | ssl3 | Negotiate SSL v3
 | tls1 | Negotiate TLS v1
COM Port Option
 | dun / nodun | DTR is Modem Escape enable / disable
 | dsr or dsrhigh | DSR Emulation set to Always High
 | dsrlow | DSR Emulation set to Always Low
 | dsrtrack | DSR Emulation set to Track Network Connection
 | nodsr | DSR Emulation disabled
 | dcd or dcdhigh | DCD Emulation set to Always High
 | dcdlow | DCD Emulation set to Always Low
 | dcdtrack | DCD Emulation set to Track Network Connection
 | nodcd | DCD Emulation disabled
 | cts or ctshigh | CTS Emulation set to Always High
 | ctslow | CTS Emulation set to Always Low
 | ctstrack | CTS Emulation set to Track Network Connection
 | nocts | CTS Emulation disabled
 | reconnect | Recover Failed Connections enabled
 | noreconnect | Recover Failed Connections disabled

Notes

Presets do not include credential information (username, password) for security reasons.

Presets are not available for Advanced Options because they affect all virtual COM ports.

All settings can be automated during installation using the Unattended Installation feature.

For the Serial/IP Redirector, settings can also be changed directly at run-time by the application using the optional ActiveX API.

Related Topics

The Presets File


Proxy Server Support

The Serial/IP Redirector supports TCP network connections made through a proxy server, which may be controlling access to external networks (such as the Internet) from a private network that lacks transparent IP-based routing, such as NAT.

Proxy server support is built into the Serial/IP Redirector because it is a driver that runs in kernel mode. Conventional proxy server support for Windows applications is provided in user mode and is unavailable to drivers.

The Serial/IP Redirector supports the following proxy protocols:

  • SOCKS v5

  • SOCKS v4

  • HTTPS

The Serial/IP Redirector is compatible with the following proxy servers:

  • Microsoft ISA (for the SOCKS protocol only)

  • Apache on Linux and Windows

  • Squid

Related Topics

Using a Proxy Server


Using a Proxy Server

To configure for a proxy server

In the Serial/IP Control Panel:

  1. Click Advanced.

  2. Click the Proxy Server tab.

  3. Select the check box Use a Proxy Server.

  4. If the proxy server requires a login, type credentials in the Username and Password fields.

  5. The Protocol Type, IP Address, and Port Number are required. Type values in these fields if you are not going to use the Auto Detect feature.

  6. To automatically locate the proxy server and detect the settings, select the Auto Detect button.

  7. If the automatic detection failed, type values in Protocol Type, IP Address, and Port Number. The value of IP Address can be entered as a hostname.

  8. Click Test to use the settings to contact the proxy server.

  9. Click OK to record the settings.

Tips

The Auto Detect command takes the following actions:

  1. A DNS lookup of “wpad” is attempted.

  2. For each IP address returned by the DNS lookup, the redirector attempts protocol detection for each supported protocol (SOCKS v5, SOCKS v4, in that order). This is done by attempting a TCP connection to the IANA-defined port for each protocol, then (if successful) attempting proxy operations.

  3. If the DNS lookup came back empty, or if no proxy server protocol has been detected, the redirector attempts protocol detection on each default gateway in the routing table.

  4. If no proxy server protocol is detected, the Auto Detect operation is terminated and no settings are automatically entered.

If operation with a proxy server is not working as expected, the following resources may be of help:

  • Verify with the "ping" command (in a DOS prompt window) that the proxy server responds at the expected IP address.

  • Use the Test command. This conducts additional checks that can not be readily performed otherwise.

The Auto Detect and Test operations will typically take less than 10 seconds. If either of these operations appear to be hung, use Stop button to terminate them.

If the proxy server requires a login, the Auto Detect and Test operations will fail if Username and Password have not been provided.

The Username and Password credentials are transmitted to the proxy server as plaintext. A Test operation will display an error dialog if these credentials are required by the proxy server but not yet entered.

If a proxy server is being used, related information will appear in the Trace display of the Serial/IP Port Monitor. details

Notes

The above references to IP Address and Port Number are for the proxy server and have nothing to do with the settings of the same name in the Serial/IP Control Panel.

Related Topics

Proxy Server Support


Using Encryption

Encryption overview

Encryption is an optional feature of the Serial/IP Redirector. Encryption is available in the redirector only if allowed by the license key. If encryption is available, each virtual COM port can be independently configured to use encryption for its connections.

The Encryption feature essentially offers three things:

  • Encryption of the data in the redirector's network connection to the serial device server. Without encryption, data on the network connection is transmitted in the clear, as read/written at the virtual COM port.

  • Authentication of the server's identity by requesting and processing its SSL certificate.

  • Transmission of the redirector's own SSL certificate, if requested by the server.

Encryption is configured in the Serial/IP Redirector using three sets of Advanced Options:

  • SSL Encryption — how data will be encrypted.

  • SSL Authentication — how a server's identity will be authenticated.

  • SSL Certificate — what SSL certificate will be supplied by the redirector, if requested.

A virtual COM port using encryption can be configured to use SSL v3 and/or TLS v1 protocols. In this document, the term SSL generally refers to both protocols, which effectively have the same functions.

Getting ready to use encryption

Before you configure the redirector:

  1. Check the requirements that apply when using encryption, which are mainly related to the network peer.

  2. If the redirector will be configured to provide an SSL certificate, you are advised to obtain your own certificate to use instead of the sample certificate provided with the Serial/IP software. The sample certificate does not provide the standard level of security.

To configure encryption

In the Serial/IP Control Panel:

  1. Click Advanced to get the Advanced Options window.

  2. In the SSL Encryption tab, adjust the default settings if:

    • you wish to restrict the available ciphers,

      OR

    • you wish to narrow the range of available cipher strengths.

  3. In the SSL Authentication tab, set up validation criteria and the certificate authority keys if:

    • any virtual COM port will accept an inbound connection with encryption,

      OR

    • you wish to use a second level of security by validating fields in the certificate that the server supplies,

      OR

    • you wish to use your own set of certificate authority keys instead of the default set.

  4. In the SSL Certificate tab, specify the redirector's certificate if:

    • any virtual COM port will accept an inbound connection with encryption,

      OR

    • the server will demand a certificate. (This is uncommon.)

NOTE: All encryption settings are global and apply to all virtual COM ports that use encryption.

To use encryption on a virtual COM port

In the Serial/IP Control Panel:

  1. Select the virtual COM port.

  2. Select the check box Use Encryption. details

  3. If the network peer is only able to use SSL v3 or TLS v1, select the corresponding setting in the drop-down list. details

NOTE: When encryption is selected for a virtual COM port, it will only connect to network peers that support encryption.

Tips

Recommended reading for detailed information: SSL and TLS: Designing and Building Secure Systems by Eric Rescorla (ISBN 0201615983)

The encryption software used by the Serial/IP Redirector is the OpenSSL toolkit. This software is incorporated in the redirector driver and is entirely independent of any other encryption support that might be used by other applications. It does not share any code or configuration information with other software running on the computer.

SSL encryption is not the same as SSH. SSH provides secure shell functions, whereas SSL encryption is used to secure TCP connections. SSH has login-related functions not needed by a redirector and SSH is a tunneling protocol that is potentially less secure because another application could use the SSH connection for unintended purposes.

Notes

A maximum cipher strength may be imposed by the license key.

Related Topics

Use Encryption


Encryption Requirements

Encryption imposes additional system requirements:

  • The Serial/IP license key must enable the Encryption features.

  • The serial device server must support SSL/TLS encryption.

  • If the redirector is making outbound connections with encryption to the serial device server, an SSL certificate must be configured on the server.

  • If the redirector is accepting inbound connections with encryption, an SSL certificate (in the form of a PEM file) must be available to configure in the redirector.

  • If you do not plan to use the redirector's default certificate authority keys, your separate certificate authority file must be available to configure in the redirector.

Tips

Certificates can be obtained in two ways: By purchase from commercial suppliers (readily found on the Internet) and by using commonly available SSL utilities.

If the serial device server does not support SSL/TLS encryption, consider using a front-end system to provide it. Examples range from SSL accelerators (often used by large web sites) to the open-source Stunnel software.

Notes

The license key automatically used in 30-day trial copies disables the Encryption features. A license key that enables Encryption can be supplied by Tactical Software.

Related Topics

Local Computer Requirements

Server Requirements

Features Controlled by the License Key


Configuring SSL Encryption

Encryption uses one of five ciphers and a cipher strength, both of which are negotiated when the SSL connection is established. The redirector includes support for:

  • Ciphers: RC2, RC4, DES, 3DES, and AES.

  • Cipher strengths: 40 bits to 256 bits.

Not all ciphers work with all strengths, and this is automatically managed when the network connection is negotiated.

To configure SSL encryption

In the Serial/IP Control Panel:

  1. Click Advanced to get the Advanced Settings window.

  2. Click the SSL Encryption tab.

  3. To change the range of encryption strengths available (for all ciphers), change the selections in the drop-down lists for Minimum and Maximum.

  4. To change the set of available ciphers, select/deselect check boxes in the Encryption Ciphers group. Your settings must make at least one cipher available.

Changes are reflected immediately in the Cipher Set Preview display. If no cipher sets appear, the configuration of strengths and ciphers must be corrected.

Tips

The default settings are 128 bit minimum strength, no limit on maximum strength (256 bits), and all ciphers selected. The resulting cipher sets are:

DHE-RSA-AES256-SHA

DHE-DSS-AES256-SHA

AES256-SHA

EDH-RSA-DES-CBC3-SHA

EDH-DSS-DES-CBC3-SHA

DES-CBC3-SHA

DHE-DSS-RC4-SHA

RC4-SHA

RC4-MD5

DHE-RSA-AES128-SHA

DHE-DSS-AES128-SHA

AES128-SHA

EXP1024-RC2-CBC-MD5

EXP1024-DHE-DSS-RC4-SHA

EXP1024-RC4-SHA

EXP1024-RC4-MD5

EXP1024-DHE-DSS-DES-CBC-SHA

EXP1024-DES-CBC-SHA

EDH-RSA-DES-CBC-SHA

EDH-DSS-DES-CBC-SHA

DES-CBC-SHA

EXP-RC2-CBC-MD5

EXP-RC4-MD5

EXP-EDH-RSA-DES-CBC-SHA

EXP-EDH-DSS-DES-CBC-SHA

EXP-DES-CBC-SHA

The available cipher sets are also determined by the server configuration. For multi-user sites, the server effectively can be a centralized way to control cipher sets for all redirectors using the server.

In the Serial/IP Port Monitor, the Activity display shows the cipher and strength being used for encrypted connections and the Trace panel shows additional information related to SSL/TLS.

Notes

These settings are global for the redirector.

The order of appearance in the cipher set preview does not affect their use when a connection is negotiated.

Related Topics

Local Computer Requirements

Server Requirements


Configuring the SSL Certificate

The redirector must be configured with an SSL certificate if it must respond to a certificate request by a server or accept inbound connections using encryption.

An sample certificate is included with the redirector. This certificate should only be used for testing and should not be considered sufficiently secure for production applications.

To configure the SSL Certificate

In the Serial/IP Control Panel:

  1. Click Advanced to get the Advanced Settings window.

  2. Click the SSL Certificate tab.

  3. Select the check box Supply Certificate.

  4. Type a filename in Certificate File or use Choose File to select the file.

  5. Click Enter Certificate Password to provide the password that the redirector must use to decode the certificate file.

  6. To preserve the certificate password for future sessions, select the check box Save Password.

Tips

The sample certificate is signed with a sample certificate authority, which is not one of the default certificate authorities. The sample certificate is in the file "samplecert.pem" in the Serial/IP installation folder. The password for the sample certificate is "password".

Notes

These settings are global for the redirector.


Configuring SSL Authentication

The Serial/IP Redirector can require the server to transmit an SSL certificate that the redirector can use to confirm the server's identity when the network connection to the server is being established.

In summary, the authentication process consists of the following steps, all of which must succeed for the SSL connection to continue:

  1. The redirector accesses the contents of the certificate supplied by the server.

  2. The redirector uses its Certificate Authority Keys to determine whether the certificate can be trusted.

  3. If the redirector has been configured with Validation Criteria, those settings are used to determine whether the connection will be allowed.

To configure SSL Authentication

In the Serial/IP Control Panel:

  1. Click Advanced to get the Advanced Settings window.

  2. Click the SSL Authentication tab.

  3. Select the check box Require Validated Certificate.

  4. To optionally specify validation criteria, select any check box and use the associated text field.

    • %h requires a match to the hostname the redirector used to connect to the server.

    • %a requires a match to the IP address the redirector used to connect to the server.

    • Any other text requires an exact match.

  5. In Certificate Authority Keys, select one of the two sources for the certificate authority keys. If using keys from a file, type the filename or select the file using Choose File.

  6. Click OK to make the changes effective.

Tips

The redirector has a built-in default set of certificate authorities.

A sample certificate authority file named "sampleca.pem" is provided in the Serial/IP installation folder. It is the certificate authority used to sign the sample certificate in "samplecert.pem".

Notes

The %h and %a entries are typically only useful for matching the Common Name field in Validation Criteria.

These settings are global for the redirector.

Related Topics

Encryption Requirements

Configuring SSL Encryption

Configuring the SSL Certificate

SSL Certificate Authorities


SSL Certificate Authorities

The default set of certificate authorities are:

ABA.ECOM, Inc.
Administracion Nacional De Correos
Belgacom
C&W HKT SecureNet CA Class B
C&W HKT SecureNet CA SGC Root
Certiposte
Certisign Certificadora Digital Ltda.
Certplus
Colegio Nacional de Correduria Publica Mexicana, A.C.
Deutsche Telekom AG
Digital Signature Trust Co.
EUnet International
Entrust.net
Equifax
Equifax Secure Inc.
FNMT
First Data Digital Certificates Inc.
Fundacion FESTE
GTE Corporation
GlobalSign nv-sa
IPS Seguridad CA
Japan Certification Services, Inc.
NetLock Halozatbiztonsagi Kft.
PTT Post
RSA Data Security, Inc.
SIA S.p.A.
Saunalahden Serveri
SecureNet
Swisskey AG
TC TrustCenter for Security in Data Networks GmbH
Thawte Consulting
The USERTRUST Network
ValiCert, Inc.
VeriSign, Inc.
ViaCode
Xcert EZ by DST

Tips

These certificate authorities are in the file "ca.pem" in the Serial/IP installation folder.

Related Topics

Configuring the SSL Certificate


Keyboard Shortcuts

Display:

Project: c-1

TOC: c-2

Styles:

Normal: c-s-N

Headings 1-3: c-a-1/2/3

Headings 4 up: c-s-S then arrow the style drop-down

Bullets/numbers: c-s-L

Preview

^W --- quick preview of a topic

^R --- build the default target

menu-V --- builds a target

Insert

Hyperlink: c-K

Pictures: c-G

Text-only popup: c-a-P

Properties/Tags

Topic/etc properties: a-Enter

Tag dialog: c-N


Tags

b - Builds

bOEM --- all OEM, all products etc.

bOEM_SI --- OEM and SI

bOEM_SI_2217 --- OEM and SI and server supports 2217

bOEM_SI_SSL

...

bTS --- non-OEM builds

bTS_DE_GE --- DE General Edition

bTS_DE_TE --- DE TacServe Edition

...

f - Features

fSSL --- encryption

p - Products

Coverage: generic to the product, regardless of build TS/OEM

Client Tags

TARGETS >> | CI | DE | DE- | DI | SI | SI- | SI- | SI- | SI- | SI-
 |  |  | TE |  |  | TE | OEM | OEM2217 | OEM2217SSL | OEMSSL
Build |  |  |  |  |  |  |  |  |  |
bOEM |  |  |  |  |  |  | x | x | x | x
bOEM_SI |  |  |  |  |  |  | x | x | x | x
bOEM_SI_2217 |  |  |  |  |  |  |  | x |  |
bOEM_SI_2217_SSL |  |  |  |  |  |  |  |  | x |
bOEM_SI_TCP |  |  |  |  |  |  | x |  |  |
bOEM_SI_TCP_SSL |  |  |  |  |  |  |  |  |  | x
bTS | x | x | x | x | x | x |  |  |  |
bTS_DE_GE |  | x |  |  |  |  |  |  |  |
bTS_DE_TE |  |  | x |  |  |  |  |  |  |
bTS_SI_GE |  |  |  |  | x |  |  |  |  |
bTS_SI_TE |  |  |  |  |  | x |  |  |  |
Features |  |  |  |  |  |  |  |  |  |
fSSL | x | x | x | x | x | x |  |  | x | x
Products |  |  |  |  |  |  |  |  |  |
pCI | x |  |  |  |  |  |  |  |  |
pDE |  | x | x |  |  |  |  |  |  |
pDI |  |  |  | x |  |  |  |  |  |
pSI |  |  |  |  | x |  | x | x | x | x
Targets |  |  |  |  |  |  |  |  |  |
tCHM | x | x | x | x | x |  | x | x | x | x
tPrint | x | x | x | x | x |  | x | x | x | x
tWeb | x | x | x | x | x |  | x | x | x | x

CI: pCI OR fSSL OR bTS OR tCHM tWeb tPrint

DE: pDE OR fSSL OR bTS OR bTS_DE_GE OR tCHM tWeb tPrint

DE-TE: pDE OR fSSL OR bTS OR bTS_DE_TE OR tCHM tWeb tPrint

DI: pDI OR fSSL OR bTS OR tCHM tWeb tPrint

SI: pSI OR fSSL OR bTS OR bTS_SI_GE OR tCHM tWeb tPrint

SI-TE: pSI OR fSSL OR bTS OR bTS_SI_TE OR tCHM tWeb tPrint

SI-OEM: pSI OR bOEM OR bOEM_SI OR bOEM_SI_TCP OR tCHM tWeb tPrint

SI-OEM2217: pSI OR bOEM OR bOEM_SI OR bOEM_SI_2217 OR tCHM tWeb tPrint

SI-OEM2217SSL: pSI OR fSSL OR bOEM OR bOEM_SI OR bOEM_SI_2217_SSL OR tCHM tWeb tPrint

SI-OEMSSL: pSI OR fSSL OR bOEM OR bOEM_SI OR bOEM_SI_TCP_SSL OR tCHM tWeb tPrint


Latest Help File Download

You can download the latest version of this document and replace the version currently displayed when you use Help in the Serial/IP Redirector.

To update the installed on-line help file

  1. Click here to initiate a download of the latest help file.

  2. Save the .chm file to a temporary location.

  3. Print these instructions so that you can refer to them as you proceed.

  4. Close all Serial/IP help windows.

  5. Rename the file you downloaded to index.chm.

  6. Double-click index.chm to open it. If the initial page does not display properly, you are running a version of Windows with an Attachment Manager that marked index.chm as an "untrusted file" when it was downloaded. To fix this problem:

    1. Right-click the file index.chm, then click Properties.

    2. Click Unblock.

    3. Click OK.

  7. Drag index.chm to the html folder in the Serial/IP software installation folder. The standard location is:

    C:\Program Files\Tactical Software\    SerialIP\html\index.chm

  8. Subsequent uses of the help file will display the new version.


End User License Agreement

THIS END USER LICENSE AGREEMENT (this “Agreement”) IS A BINDING AGREEMENT BETWEEN TACTICAL SOFTWARE, LLC (“Tactical”) AND THE INDIVIDUAL, COMPANY, ORGANIZATION OR OTHER ENTITY (“Licensee”) ACQUIRING THE LICENSE TO USE THE SOFTWARE PRODUCT (AS DEFINED IN SECTION 1) PURSUANT TO THIS AGREEMENT. IN THE EVENT LICENSEE IS AN ENTITY, LICENSEE AND THE INDIVIDUAL REVIEWING AND ACCEPTING THE TERMS OF THIS AGREEMENT ON BEHALF OF LICENSEE, EACH REPRESENT AND WARRANT THAT SUCH INDIVIDUAL IS AUTHORIZED TO ACT ON BEHALF OF LICENSEE TO REVIEW AND ACCEPT THIS AGREEMENT AND TO BIND LICENSEE TO THE TERMS AND CONDITIONS HEREOF. IF THE INDIVIDUAL REVIEWING THIS AGREEMENT DOES NOT HAVE SUCH AUTHORITY, THEN THE SOFTWARE PRODUCT MAY NOT BE INSTALLED OR USED BY LICENSEE.

BY INSTALLING OR OTHERWISE USING THIS SOFTWARE PRODUCT, LICENSEE AGREES TO BE BOUND BY THE TERMS AND CONDITIONS OF THIS AGREEMENT. IF LICENSEE DOES NOT AGREE TO ALL OF THE TERMS AND CONDITIONS OF THIS AGREEMENT, LICENSEE MAY NOT CONTINUE THIS INSTALLATION OR OTHER USE AND MUST DELETE ANY PORTION OF THE SOFTWARE PRODUCT ALREADY INSTALLED, IF ANY.

1. LICENSE TYPE AND LICENSE GRANT

(a) If the Software Product is used with an Evaluation License Key (as defined below), Tactical grants to Licensee a non-exclusive, non-transferable, limited license for an evaluation period (the “Evaluation Period”), the term of which shall be determined by Tactical, to use:

  1. the Tactical software installed or otherwise accessed by Licensee (the “Software Product”) for internal evaluation of the Software Product only; and

  2. the documentation accompanying the Software Product (the “Documentation”).

(b) If the Software Product is used with a Deployment License Key (as defined below), Tactical grants to Licensee a non-exclusive, non-transferable license, for the applicable license term (the "License Term"), to use:

  1. the Software Product for internal use only; and

  2. the Documentation.

(c) The type of license granted to Licensee and certain restrictions regarding Licensee’s use of the Software Product may be set forth in a certificate (the "License Certificate") that contains one or more License Keys (as defined below). If the Software Product is used with any of the License Keys listed in a License Certificate, that License Certificate is incorporated herein and is deemed to be a part of this Agreement.

(d) The Software Product is being “used” on a computer when it is resident in memory (i.e., RAM) or when the executable or other files of the Software Product are installed on the hard drive or other storage device of the computer.

(e) A "License Key" is an alphanumeric value required by the Software Product. An "Evaluation License Key" is a License Key that permits operation of the Software Product for a period of time. A "Deployment License Key" is a License Key that permits operation during the License Term.

2. CERTAIN RESTRICTIONS

(a) Licensee may not, and Licensee may not permit others, to (i) reverse engineer, decompile, or disassemble the Software Product, or otherwise attempt to derive the source code of the Software Product, except to the extent (if at all) expressly permitted under any applicable law. If applicable law expressly permits such activities, any information so discovered or derived shall be deemed to be the confidential proprietary information of Tactical and Licensee must promptly disclose such information to Tactical.

(b) Any attempt by Licensee to transfer any of Licensee’s rights, duties or obligations hereunder is void. Licensee shall not rent, lease or loan the Software Product.

(c) Licensee may not, and Licensee may not permit others, to (i) copy, modify, translate, or create derivative works from, the Software Product or the Documentation, or (ii) remove any proprietary notices in, or labels on, the Software Product or the Documentation, including copyright, trademark or patent notices.

3. BACKUP COPY

Licensee may make a reasonable number of copies of the Software Product solely for backup or archival purposes. Licensee may not make any copies of the Software Product, except as expressly provided in this Section, or as permitted in Section 1 (but only to the extent necessary to use the Software Product in accordance with the license granted in Section 1), and any such copy must include all copyright and other intellectual property and proprietary notices that are in the original copy of the Software Product.

4. SOFTWARE PRODUCT

(a) The Software Product includes any updates, upgrades, fixes, and other supplements to the original Software Product provided to Licensee by Tactical, if any, and Licensee’s use of any such updates, upgrades, fixes, and other supplements shall be subject to the terms, conditions, and restrictions of this Agreement.

(b) Tactical reserves the right at any time to alter features, capabilities, functions, release dates, general availability or any other characteristics of the Software Product as Tactical deems appropriate in its sole discretion.

5. TITLE

The Software Product and the Documentation are licensed, not sold. Title, ownership rights, and intellectual property rights in and to the Software Product and the Documentation remain with Tactical. The Software Product and the Documentation are protected by the copyright and other intellectual property rights laws of the United States and international copyright treaties and international law.

6. NO VIRUSES, WORMS OR TROJAN HORSES

As of the date Licensee first downloads the Software Product or first receives a copy of the Software Product from Tactical, to Tactical’s knowledge, the Software Product does not contain any virus, worm, or Trojan horse which would cause damage to Licensee’s software or data.

7. INTELLECTUAL PROPERTY WARRANTIES

Tactical represents and warrants to Licensee that Tactical owns or has all necessary rights, authorizations and licenses to enable Tactical to license the Software Product and Documentation in accordance with the provisions of this Agreement and that the Software Product and Documentation do not infringe or otherwise violate the copyright rights of any third party.

8. WARRANTY; LIMITATIONS

(a) Notwithstanding anything to the contrary in this Agreement, the Software Product is delivered to Licensee for the Evaluation Period “AS IS”, without any warranty of any kind, whether express or implied. Without limiting the generality of the foregoing, the Limited Warranties (as defined in Section 8(d)) do not apply during the Evaluation Period.

(b) Tactical warrants that the Software Product will perform substantially in accordance with the Documentation for a period of ninety (90) days from date Licensee acquires its initial copy of the Software Product (by download, delivery of physical media containing the Software Product, or other method of delivery).

(c) In addition, Tactical warrants that the storage media on which the Software Product is delivered directly from Tactical to Licensee shall be free from defects for a period of ninety (90) days from date Licensee acquires its initial copy of the Software Product on such storage media directly from Tactical. In the event that such media does not conform to such warranty, Licensee shall return such non-conforming media to Tactical, and Tactical’s entire liability and Licensee’s exclusive remedy shall be, at Tactical’s expense, to replace such non-conforming media.

(d) EXCEPT AS EXPRESSLY PROVIDED IN SECTION 6, 7, 8(B), and 8(C) (collectively, the "Limited Warranties"), THERE ARE NO WARRANTIES, CONDITIONS OR REPRESENTATIONS, EXPRESS OR IMPLIED BY STATUTE, USAGE, CUSTOM OF TRADE OR OTHERWISE WITH RESPECT TO THE SOFTWARE PRODUCT OR DOCUMENTATION, INCLUDING BUT NOT LIMITED TO, WARRANTIES OR REPRESENTATIONS OF WORKMANSHIP, MERCHANTABILITY, SUITABILITY OR FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, OR NON-INFRINGEMENT. WITHOUT LIMITING THE GENERALITY OF THE FOREGOING, TACTICAL DOES NOT WARRANT THAT THE SOFTWARE PRODUCT WILL MEET ALL OF LICENSEE’S NEEDS OR THAT OPERATION OF THE SOFTWARE PRODUCT WILL BE ERROR-FREE. THIS LIMITED WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS AGREEMENT.

9. REMEDY

In the event of a breach of any of the Limited Warranties (other than the Limited Warranty set forth in Section 8(c)), Tactical’s entire liability and Licensee’s exclusive remedy shall be, at Tactical’s option and expense, to either (a) refund the amount of the license fee actually paid by Licensee for the non-conforming Software Product (in which event this Agreement shall terminate), (b) repair the non-conforming Software Product by providing a patch, work-around or other reasonable solution, or (c) replace the non-conforming Software Product. The Limited Warranties do not apply in the event that non-conformance of the Software Product with a Limited Warranty results from accident, abuse, or misapplication (including use of the Software Product together with a software operating system or software and hardware environment which does not meet the specifications set forth in the Documentation). Any replacement Software Product will be warranted for the remainder of the original warranty period or thirty (30) days from the date on which the replacement Software Product is delivered, whichever is longer.

10. LIMITATION OF LIABILITY

UNDER NO CIRCUMSTANCES AND UNDER NO LEGAL THEORY, WHETHER IN TORT, CONTRACT, OR OTHERWISE, SHALL TACTICAL BE LIABLE FOR ANY INDIRECT, SPECIAL, INCIDENTAL, PUNITIVE, EXEMPLARY OR CONSEQUENTIAL DAMAGES OF ANY CHARACTER RELATING TO THE SOFTWARE PRODUCT, THE DOCUMENTATION, OR THIS AGREEMENT, INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF TACTICAL HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. SOME JURISDICTIONS DO NOT ALLOW A LIMITATION ON CONSEQUENTIAL DAMAGES, SO THE ABOVE LIMITATION MAY NOT APPLY TO LICENSEE. IN NO EVENT WILL TACTICAL BE LIABLE FOR ANY DAMAGES WHATSOEVER IN EXCESS OF THE AMOUNT PAID TO TACTICAL FOR THE SOFTWARE PRODUCT THAT IS THE SUBJECT MATTER OF THE CLAIM OR THAT IS DIRECTLY RELATED TO THE CAUSE OF ACTION.

11. TERM AND TERMINATION

(a) This Agreement shall become effective upon installation of the Software Product and shall terminate automatically and immediately upon breach of this Agreement by Licensee, if any. Licensee may terminate this Agreement for convenience by removal of the Software Product from all Licensee’s systems upon fifteen (15) days prior written notice to Tactical.

(b) Licensee agrees that, in the event of any termination of the license of the Software Product (including termination resulting from the termination of this Agreement), Licensee shall, within fifteen (15) days following such termination, purge all copies of the Software Product and the Documentation from all computers and storage media on which Licensee has maintained them, destroy all copies of the Software Product and the Documentation, and promptly certify in writing to Tactical that the same have been purged and destroyed.

(c) Termination of this Agreement shall not relieve either party of any payment or other obligation under this Agreement which was to have been performed by such party prior to the termination. All provisions of this Agreement which by their nature are intended to survive the termination of this Agreement (including the provisions of Sections 2, 5, 8(c), 9, 10, 11(b), this 11(c), 12, 13, and 14) shall survive such termination.

12. DISPUTE RESOLUTION

(a) If any dispute arises between Tactical and Licensee pertaining to this Agreement which Tactical and Licensee are unable to resolve amicably, such dispute shall be submitted to arbitration before a single arbitrator selected in accordance with the then-prevailing Rules of Commercial Arbitration of the American Arbitration Association. The arbitration proceeding shall take place in Manchester, New Hampshire or such other location as Tactical and Licensee may mutually agree.

(b) The arbitrator shall not contravene or vary in any respect any of the terms or provisions of this Agreement. The award of the arbitrators shall be final and binding upon Tactical and Licensee, and judgment upon any award rendered therein may be entered and enforced in any court of competent jurisdiction, including the New Hampshire Superior Court.

(c) Neither this arbitration provision nor a pending arbitration shall prevent either party from obtaining injunctive relief for any matter at any time.

13. EXPORT

Licensee acknowledges and accepts responsibility for complying with all import and export statutes, regulations, treaties and other laws, both foreign and domestic, (collectively, the “Export Laws”) and agrees to not use or otherwise export or re-export, directly or indirectly, the Software Product except in accordance with the Export Laws. In particular, but without limitation, the Software Product may not be exported or re-exported, directly or indirectly,

(a) into (or to a national or resident of) any U.S. embargoed country, as such list may be revised from time to time (including without limitation Afghanistan, Cuba, Iran, Iraq, Libya, North Korea, Sudan or Syria), or

(b) to anyone on the U.S. Treasury Department list of Specially Designated Nationals or the U.S. Bureau of Industry and Security Denied Persons List or the U.S. Bureau of Industry and Security Unverified List, or

(c) for any end-use that is prohibited by United States law or the laws of the jurisdiction in which the Software Product was obtained.

Licensee represents and warrants that Licensee is not located in, under control of, or a national or resident of any such country or on any such list and that no U.S. federal agency has suspended, revoked, or denied Licensee's import or export privileges.

14. MISCELLANEOUS

(a) If any provision of this Agreement is held to be unenforceable for any reason, such provision shall be reformed only to the extent necessary to make it enforceable, and shall not affect the other provisions of this Agreement.

(b) This Agreement shall be governed by and construed under New Hampshire law, without regard for its conflicts of law provisions. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

(c) This Agreement constitutes the entire agreement between Tactical and Licensee regarding the subject matter hereof and supersedes all prior or simultaneous representations, discussions, negotiations, and agreements, whether written or oral.

(d) Licensee may assign this Agreement only to any entity to which it transfers all or substantially all of its assets, provided the assignee agrees to be bound by the terms of this Agreement. Otherwise, Licensee may not assign or have assumed, voluntarily, by operation of law, in bankruptcy or otherwise, any rights or delegate any duties under this Agreement without Tactical’s prior written consent, and any attempt to do so without such consent will be null and void. This Agreement will bind and inure to the benefit of the parties and their respective successors and permitted assigns.

(e) This Agreement may be amended or supplemented only by a writing that is signed by duly authorized representatives of both parties. No term or provision hereof will be considered waived by either party, and no breach excused by either party, unless such waiver or consent is in writing signed on behalf of the party against whom the waiver is asserted. No consent by either party to, or waiver of, a breach by either party, will constitute a consent to, waiver of, or excuse of any other, different, or subsequent breach by either party.

15. U.S. GOVERNMENT LICENSES

The Software Product and Documentation are provided with "restricted rights". Use, duplication or disclosure of the Software Product or the Documentation by the Government is subject to restrictions as set forth in Subparagraph 252.227-7015 (Technical Data - Commercial Items) of the Department of Defense Federal Acquisition Regulations Supplement ("DFARs") and other sections of DFARS applicable to commercial software, or Subparagraphs 52.227-19(c)(1) and (c)(2) (Commercial Computer Software - Restricted Rights) of Title 48 of the Code of Federal Regulations ("FARs") and other sections of FARS applicable to commercial software, as applicable.

16. OpenSSL Toolkit LICENSE

/* ====================================================================
* Copyright (c) 1998-2003 The OpenSSL Project. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* 1. Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
*
* 2. Redistributions in binary form must reproduce the above copyright
* notice, this list of conditions and the following disclaimer in
* the documentation and/or other materials provided with the
* distribution.
*
* 3. All advertising materials mentioning features or use of this
* software must display the following acknowledgment:
* "This product includes software developed by the OpenSSL Project
* for use in the OpenSSL Toolkit. (http://www.openssl.org/)"
*
* 4. The names "OpenSSL Toolkit" and "OpenSSL Project" must not be used to
* endorse or promote products derived from this software without
* prior written permission. For written permission, please contact
* openssl-core@openssl.org.
*
* 5. Products derived from this software may not be called "OpenSSL"
* nor may "OpenSSL" appear in their names without prior written
* permission of the OpenSSL Project.
*
* 6. Redistributions of any form whatsoever must retain the following
* acknowledgment:
* "This product includes software developed by the OpenSSL Project
* for use in the OpenSSL Toolkit (http://www.openssl.org/)"
*
* THIS SOFTWARE IS PROVIDED BY THE OpenSSL PROJECT ``AS IS'' AND ANY
* EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OpenSSL PROJECT OR
* ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
* ====================================================================
*
* This product includes cryptographic software written by Eric Young
* (eay@cryptsoft.com). This product includes software written by Tim
* Hudson (tjh@cryptsoft.com).
*
*/

Tactical Software LLC
15 Constitution Drive
Bedford, New Hampshire, 03110 USA

Copyright © 1996-2008 Tactical Software, LLC. All rights reserved.

Rev. 10